// AutoPosition.cpp : implementation file
//

#include "stdafx.h"
#include "VIDCAP01.h"
#include "AutoPosition.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAutoPosition property page


IMPLEMENT_DYNCREATE(CAutoPosition, CPropertyPage)

CAutoPosition::CAutoPosition() : CPropertyPage(CAutoPosition::IDD)
{
	//{{AFX_DATA_INIT(CAutoPosition)
	m_ZoomAutoPosition = 0;
	m_PanReverse = FALSE;
	m_TiltReverse = FALSE;
	m_AutoPositionCorrectionFactorString = _T("");
//	m_LockZoom = FALSE;
	m_EditText = _T("");
	m_EditZoomPosition = 0;
	//}}AFX_DATA_INIT
}

CAutoPosition::~CAutoPosition()
{
}

void CAutoPosition::PassPointer(CWnd *pnt)
{
m_pParent=(CVIDCAP01Dlg*) pnt;
}

void CAutoPosition::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAutoPosition)
	DDX_Check(pDX, IDC_CHECKPANREVESE, m_PanReverse);
	DDX_Check(pDX, IDC_CHECKTILTREVERSE, m_TiltReverse);
	DDX_Text(pDX, IDC_EDITXCENTEROFFSET, m_XCenterOffset);
	DDX_Text(pDX, IDC_EDITYCENTEROFFSET, m_YCenterOffset);
	DDX_Text(pDX, IDC_EDITTEXT, m_EditText);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CAutoPosition, CPropertyPage)
	//{{AFX_MSG_MAP(CAutoPosition)
	ON_WM_CLOSE()
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_CHECKTILTREVERSE, OnChecktiltreverse)
	ON_BN_CLICKED(IDC_CHECKPANREVESE, OnCheckpanrevese)
	ON_BN_CLICKED(IDC_BUTTONSETOFFSET, OnButtonsetoffset)
	ON_WM_HSCROLL()
	ON_BN_CLICKED(IDC_BUTTONDEFAULTOFFSETS, OnButtondefaultoffsets)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CAutoPosition message handlers


  
BOOL CAutoPosition::OnInitDialog() 
{
	//long Flags;
	
	CPropertyPage::OnInitDialog();
	if (m_pParent->m_CameraType <4)
	{
		MessageBox("Note","Installed Camera Type Does Not Support Auto Positioning");
		
	}
	m_XCenterOffset=m_pParent->m_XCenterOffset;
	m_YCenterOffset=m_pParent->m_YCenterOffset;
	m_PanReverse=m_pParent->m_PanReverse;
	m_TiltReverse=m_pParent->m_TiltReverse;
    
	CString String1,String2,String3,String4,StringBlank,String5, String6
		     ,String7,String8,String9, String10, String11, String12 ;
	String4="--------- Center Face Feature ---------- ";
	String1="1. Position cursor on face feature "; 
	String2="2. Double click left mouse button  "; 
	String3="3. Face feature will center to X,Y ";
	String6="2. Hold down left mouse button     ";
	String5="--------- Move Face Feature ----------   ";
	StringBlank="                                                         ";
	String7="3. Drag cursor to desired location ";
	String8="4. Release left mouse button       ";
	String9="--------- Set X,Y Offsets ---------------- ";
	String10="1. Click SetOffset button                ";
	String11="2. Move cursor to desired location  ";
	String12="3. Click left mouse button               ";
	m_EditText=String4+String1  + String2  +String3 + StringBlank + String5 + String1 +
		       String6 +String7 +String8 + StringBlank +String9 +String10 +String11 +String12;
	UpdateData(FALSE);
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}



void CAutoPosition::OnClose() 
{
	// TODO: Add your message handler code here and/or call default

	CPropertyPage::OnClose();
}



void CAutoPosition::OnDestroy() 
{
	CPropertyPage::OnDestroy();
	UpdateData(TRUE);
}



void CAutoPosition::OnChecktiltreverse() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	m_pParent->m_TiltReverse =m_TiltReverse;
	
}


void CAutoPosition::OnCheckpanrevese() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	m_pParent->m_PanReverse =m_PanReverse;
}




void CAutoPosition::OnButtonsetoffset() 
{
	// TODO: Add your control notification handler code here
	m_pParent->m_SetAutoPositionOffset=TRUE;
	
}


void CAutoPosition::UpdateOffsets(int x, int y)
{
x=x-m_pParent->m_CropWidth/2;
y=m_pParent->m_CropHeight/2-y;
m_XCenterOffset=x;
m_YCenterOffset=y;
m_pParent->m_XCenterOffset =x;
m_pParent->m_YCenterOffset =y;
UpdateData(FALSE);
}


void CAutoPosition::OnButtondefaultoffsets() 
{
	m_pParent->m_SetAutoPositionOffset=FALSE;
	m_pParent->m_XCenterOffset=m_XCenterOffset =0;
    m_pParent->m_YCenterOffset=m_YCenterOffset =0;
	UpdateData(FALSE);
}
