// PropAdjust.cpp : implementation file
//

#include "stdafx.h"
#include "VIDCAP01.h"
#include "PropAdjust.h"
#include "VAL_USB.h"
#include "MyPropSheet.h"
#include  "USB_SDK Definitions.h"
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CPropAdjust property page

//IMPLEMENT_DYNCREATE(CPropAdjust, CPropertyPage)

CPropAdjust::CPropAdjust() : CPropertyPage(CPropAdjust::IDD)
{
	//{{AFX_DATA_INIT(CPropAdjust)
	m_FlashDelay = 0;
	m_FlashRed = 0;
	m_LiveBlue = 0;
	m_LiveRed = 0;
	m_LiveColor = 0;
	m_FlashColor = 0;
	m_FlashBlue = 0;
	m_PTZSpeed = -1;
	m_RadioAutoWhite = -1;
	m_FlashColorCorrectionType = -1;
	//}}AFX_DATA_INIT
}


void CPropAdjust::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPropAdjust)
	DDX_Control(pDX, IDC_SPINFLASHRED, m_CSpinFlashRed);
	DDX_Control(pDX, IDC_SPINFLASHCOLOR, m_CSpinFlashColor);
	DDX_Control(pDX, IDC_SPINFLASHBLUE, m_CSpinFlashBlue);
	DDX_Control(pDX, IDC_SPINLIVECOLOR, m_CSpinLiveColor);
	DDX_Control(pDX, IDC_SPINLIVEBLUE, m_CSpinLiveBlue);
	DDX_Control(pDX, IDC_SPINLIVERED, m_CSpinLiveRed);
	DDX_Text(pDX, IDC_EDITFLASHDELAY, m_FlashDelay);
	DDX_Text(pDX, IDC_EDITFLASHRED, m_FlashRed);
	DDX_Text(pDX, IDC_EDITLIVEBLUE, m_LiveBlue);
	DDX_Text(pDX, IDC_EDITLIVERED, m_LiveRed);
	DDX_Text(pDX, IDC_EDITLIVECOLOR, m_LiveColor);
	DDX_Text(pDX, IDC_EDITFLASHCOLOR, m_FlashColor);
	DDX_Text(pDX, IDC_EDITFLASHBLUE, m_FlashBlue);
	DDX_Radio(pDX, IDC_RADIOSLOW, m_PTZSpeed);
	DDX_Radio(pDX, IDC_RADIOAUTOWHITE, m_RadioAutoWhite);
	DDX_Radio(pDX, IDC_RADIOFLASHCOLORCORRECTIONDEFAULT, m_FlashColorCorrectionType);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CPropAdjust, CPropertyPage)
	//{{AFX_MSG_MAP(CPropAdjust)
	ON_BN_CLICKED(IDC_CLOSEDIALOG, OnClosedialog)
	ON_WM_CLOSE()
	ON_BN_CLICKED(IDC_PAGEDEFAULTS, OnPagedefaults)
	ON_NOTIFY(UDN_DELTAPOS, IDC_SPINLIVERED, OnDeltaposSpinlivered)
	ON_NOTIFY(UDN_DELTAPOS, IDC_SPINLIVEBLUE, OnDeltaposSpinliveblue)
	ON_NOTIFY(UDN_DELTAPOS, IDC_SPINLIVECOLOR, OnDeltaposSpinlivecolor)
	ON_NOTIFY(UDN_DELTAPOS, IDC_SPINFLASHRED, OnDeltaposSpinflashred)
	ON_NOTIFY(UDN_DELTAPOS, IDC_SPINFLASHBLUE, OnDeltaposSpinflashblue)
	ON_NOTIFY(UDN_DELTAPOS, IDC_SPINFLASHCOLOR, OnDeltaposSpinflashcolor)
	ON_WM_SHOWWINDOW()
	ON_WM_HSCROLL()
	ON_BN_CLICKED(IDC_RADIOAUTOWHITE, OnRadioautowhite)
	ON_BN_CLICKED(IDC_RADIOAUTOMANUAL, OnRadioautomanual)
	ON_BN_CLICKED(IDC_RADIOFLASHCOLORCORRECTIONDEFAULT, OnRadioflashcolorcorrectiondefault)
	ON_BN_CLICKED(IDC_RADIOFLASHCOLORCORRECTIONFLU, OnRadioflashcolorcorrectionflu)
	ON_BN_CLICKED(IDC_RADIOMEDIUM, OnRadiomedium)
	ON_BN_CLICKED(IDC_RADIOSLOW, OnRadioslow)
	ON_BN_CLICKED(IDC_RADIOFAST, OnRadiofast)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPropAdjust message handlers

void CPropAdjust::OnClosedialog() 
{
	// TODO: Add your control notification handler code here
    
	SendMessage(WM_CLOSE);
	
}

//extern CPropAdjust*  m_pAdjustDialog;
void CPropAdjust::OnClose() 
{
	
	m_pParent->SetWindowPos(NULL, MainRect.left, MainRect.top, 0, 0, SWP_NOSIZE || SWP_SHOWWINDOW );
	CDialog::OnClose();
	delete(this);
}



void CPropAdjust::SetControls()

{
	m_CSpinFlashColor.SetPos(m_pParent->m_FlashChromaLevel);
	m_FlashColor=m_pParent->m_FlashChromaLevel;	

	m_CSpinLiveColor.SetPos(m_pParent->m_ChromaLevel);
	m_LiveColor=m_pParent->m_ChromaLevel;
	
	//****************** Support for Older Camera Types*************************************************
	if (m_pParent->m_CameraType<3) {
        m_CSpinFlashRed.EnableWindow(FALSE);
	    m_CSpinFlashBlue.EnableWindow(FALSE);
		m_CSpinLiveRed.EnableWindow(FALSE);
	    m_CSpinLiveBlue.EnableWindow(FALSE);
        
	}
	//*********************** Support for Newer Camera Types**************************************************
	else{	
	    m_CSpinFlashRed.SetPos(m_pParent->m_RedFlashOffset);
		m_CSpinFlashBlue.SetPos(m_pParent->m_BlueFlashOffset);		
	
		m_FlashRed=m_pParent->m_RedFlashOffset;
		m_FlashBlue=m_pParent->m_BlueFlashOffset;
		m_FlashColor=m_pParent->m_FlashChromaLevel;		
		
		m_CSpinLiveRed.SetPos(m_pParent->m_RedPreviewOffset);
		m_CSpinLiveBlue.SetPos(m_pParent->m_BluePreviewOffset);
        m_CSpinLiveColor.SetPos(m_pParent->m_ChromaLevel);
		m_LiveRed=m_pParent->m_RedPreviewOffset;
		m_LiveBlue=m_pParent->m_BluePreviewOffset;
		m_LiveColor=m_pParent->m_ChromaLevel;				
      }	
	
	//***************** AutoWhite is On*************************************
	if (m_pParent->m_AutoWhite==1){
	  m_RadioAutoWhite=0;
	  
	  m_LiveRed=m_pParent->m_RedPreviewOffset=0;
	  m_CSpinLiveRed.SetPos(0);
	  m_CSpinLiveRed.EnableWindow(FALSE);	
	  
	  m_LiveBlue=m_pParent->m_BluePreviewOffset=0;
	  m_CSpinLiveBlue.SetPos(0);
	  m_CSpinLiveBlue.EnableWindow(FALSE);
	}
	else{
	  //************************* AutoWhite is Off******************************************
	  m_RadioAutoWhite=1;
	  m_LiveRed=m_pParent->m_RedPreviewOffset;
	  m_CSpinLiveRed.SetPos(m_LiveRed);
	  m_CSpinLiveRed.EnableWindow(TRUE);	

	  m_LiveBlue=m_pParent->m_BluePreviewOffset;
	  m_CSpinLiveBlue.SetPos(m_LiveBlue);
	  m_CSpinLiveBlue.EnableWindow(TRUE);
	}

  //*********** SetDefault PTZ speed to medium***********************************************************.
	m_PTZSpeed=1;
	
  //************** Set ColorCorrection Radio Button to match DLL Setting
  m_FlashColorCorrectionType=m_pParent->m_FlashColorCorrectionType;

  UpdateData(FALSE);
}


void CPropAdjust::PassPointer(CWnd *pnt)
{
m_pParent=(CVIDCAP01Dlg*) pnt;
}


BOOL CPropAdjust::OnInitDialog() 
{
	CPropertyPage::OnInitDialog();
   
    m_CSpinLiveRed.SetRange32(-25,25);

	m_CSpinLiveBlue.SetRange32(-25,25);

	m_CSpinLiveColor.SetRange32(20,100);

	m_CSpinFlashRed.SetRange32(-25,25);

    m_CSpinFlashBlue.SetRange32(-25,50);

	m_CSpinFlashColor.SetRange32(20,100);	

	SetControls();
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}


void CPropAdjust::OnPagedefaults() 
{
  	CString str;
		
	VALCam_Control(VC_SetPreviewDefaults,0,0,0,0);
	VALCam_Control(VC_SetFlashDefaults,0,0,0,0);
 	
	//******************************Activate AutoWhite*******************************************************
	m_RadioAutoWhite=0;
	m_pParent->m_AutoWhite=1;
       
	m_LiveRed=m_pParent->m_RedPreviewOffset=VALCam_Control(VC_ReturnLiveRed,0,0,0,0);
	m_CSpinLiveRed.SetPos(m_LiveRed);
	m_CSpinLiveRed.EnableWindow(FALSE);
	
	m_LiveBlue=m_pParent->m_BluePreviewOffset=VALCam_Control(VC_ReturnLiveBlue,0,0,0,0);
	m_CSpinLiveBlue.SetPos(m_LiveBlue);
	m_CSpinLiveBlue.EnableWindow(FALSE);

	m_pParent->m_ChromaLevel=VALCam_Control(VC_ReturnLiveColor,0,0,0,0);
	m_CSpinLiveColor.SetPos (m_pParent->m_ChromaLevel);
	m_CSpinLiveColor.EnableWindow(TRUE);
	
	//*********************************** Flash Defaults*******************************************************  
	m_FlashRed=m_pParent->m_RedFlashOffset=VALCam_Control(VC_ReturnFlashRed,0,0,0,0);
	m_FlashBlue=m_pParent->m_BlueFlashOffset=VALCam_Control(VC_ReturnFlashBlue,0,0,0,0);
	m_FlashColor=m_pParent->m_FlashChromaLevel=VALCam_Control(VC_ReturnFlashColor,0,0,0,0);
	 		  	       
	m_CSpinFlashRed.SetPos(m_pParent->m_RedFlashOffset);
	m_CSpinFlashBlue.SetPos(m_pParent->m_BlueFlashOffset);	
	m_CSpinFlashColor.SetPos(m_pParent->m_FlashChromaLevel);//Parent->m_FlashChromaLevel);
	  
	UpdateData(FALSE);		   	
}



//*********** Sets Live Red Color*************************************
void CPropAdjust::OnDeltaposSpinlivered(NMHDR* pNMHDR, LRESULT* pResult) 
{
	CString str;
	NM_UPDOWN* pNMUpDown = (NM_UPDOWN*)pNMHDR;
	
	
	UpdateData(TRUE);    	
	
	if (pNMUpDown->iDelta==-1){
		m_LiveRed--; 				
	}
	else{
		m_LiveRed++; 	 
	}
	
	VALCam_Control(VC_SetRedLive,m_LiveRed,0,0,0);
	m_pParent->m_RedPreviewOffset=m_LiveRed;	
	
	*pResult = 0;
}


// ********************* Set Live Blue Color*********************************************
void CPropAdjust::OnDeltaposSpinliveblue(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_UPDOWN* pNMUpDown = (NM_UPDOWN*)pNMHDR;
	
	UpdateData(TRUE);    			
	if (pNMUpDown->iDelta==-1){
		m_LiveBlue--; 
	}
	else{
		m_LiveBlue++; 		 
	}
		
	m_pParent->m_BluePreviewOffset=m_LiveBlue; 	
    VALCam_Control(VC_SetBlueLive,m_LiveBlue,0,0,0);
 	*pResult = 0;
}


//************************** Sets Live Color Level*************************************************
void CPropAdjust::OnDeltaposSpinlivecolor(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_UPDOWN* pNMUpDown = (NM_UPDOWN*)pNMHDR;
	
	m_pParent->m_ChromaLevel=m_CSpinLiveColor.GetPos();
	VALCam_Control(VC_SetColorLive,m_pParent->m_ChromaLevel,0,0,0);
	*pResult = 0;
}

//************************** Sets camera red used for flash captures************************************
void CPropAdjust::OnDeltaposSpinflashred(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_UPDOWN* pNMUpDown = (NM_UPDOWN*)pNMHDR;
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	
	VALCam_Control(VC_SetRedFlash,m_FlashRed,0,0,0);
	m_pParent->m_RedFlashOffset=m_FlashRed;
	*pResult = 0;
}
//************************** Sets camera blue used for flash captures************************************
void CPropAdjust::OnDeltaposSpinflashblue(NMHDR* pNMHDR, LRESULT* pResult) 
{

	NM_UPDOWN* pNMUpDown = (NM_UPDOWN*)pNMHDR;
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	VALCam_Control(VC_SetBlueFlash,m_FlashBlue,0,0,0);
	m_pParent->m_BlueFlashOffset=m_FlashBlue;
	*pResult = 0;
}


//************************** Sets camera blue used for flash captures ************************************
void CPropAdjust::OnDeltaposSpinflashcolor(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_UPDOWN* pNMUpDown = (NM_UPDOWN*)pNMHDR;
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	
	VALCam_Control(VC_SetColorFlash,m_FlashColor,0,0,0);
	m_pParent->m_FlashChromaLevel=m_FlashColor;
	*pResult = 0;
}


void CPropAdjust::OnShowWindow(BOOL bShow, UINT nStatus) 
{
	CPropertyPage::OnShowWindow(bShow, nStatus);
	

	
}

void CPropAdjust::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	// TODO: Add your message handler code here and/or call default
	
	CPropertyPage::OnHScroll(nSBCode, nPos, pScrollBar);
}



//************* Activates Camera AutoWhite and sets sliders to 0.**********************************
void CPropAdjust::OnRadioautowhite() 
{

	m_RadioAutoWhite=0;
	m_pParent->m_AutoWhite=1;
    VALCam_Control(VC_AutoWhite,0,0,0,0);
    
	m_LiveRed=m_pParent->m_RedPreviewOffset=0;
	m_CSpinLiveRed.SetPos(0);
	m_CSpinLiveRed.EnableWindow(FALSE);
	
	m_LiveBlue=m_pParent->m_BluePreviewOffset=0;
	m_CSpinLiveBlue.SetPos(0);
	m_CSpinLiveBlue.EnableWindow(FALSE);

	m_pParent->m_ChromaLevel=72;
	m_CSpinLiveColor.SetPos (72);
	m_CSpinLiveColor.EnableWindow(TRUE);

	UpdateData(FALSE);
}
	

//******* Turns off AutoWhite and allows control of live camera color
void CPropAdjust::OnRadioautomanual() 
{
UpdateData(TRUE);

m_RadioAutoWhite=1;
m_pParent->m_AutoWhite=0;

//Sleep(50);	

m_CSpinLiveRed.EnableWindow(TRUE);	
m_CSpinLiveBlue.EnableWindow(TRUE);

//************ VC_SetBlueLive and VC_SetRedLive turn off AutoWhite*************************************
VALCam_Control(VC_SetBlueLive,m_LiveBlue,0,0,0);
VALCam_Control(VC_SetRedLive,m_LiveRed,0,0,0);

UpdateData(FALSE);
}

void CPropAdjust::OnRadioflashcolorcorrectiondefault() 
{
m_FlashColorCorrectionType=m_pParent->m_FlashColorCorrectionType=0;

//************************ Set Flash Color Correction for none *******************************
VALCam_Control(VC_SetFlashColorCorrection,0,0,0,0);
UpdateData(FALSE);

	
}

void CPropAdjust::OnRadioflashcolorcorrectionflu() 
{
m_FlashColorCorrectionType=m_pParent->m_FlashColorCorrection=1;

//************************ Set Flash Color Correction for Fluorescent Lighting*********************************
VALCam_Control(VC_SetFlashColorCorrection,1,0,0,0);
UpdateData(FALSE);
}


void CPropAdjust::OnRadiomedium() 
{
	m_pParent->m_PTZSpeed=1;
	
}

void CPropAdjust::OnRadioslow() 
{
	m_pParent->m_PTZSpeed=0;
}

void CPropAdjust::OnRadiofast() 
{
  	m_pParent->m_PTZSpeed=2;
}
