// PropAdvanced.cpp : implementation file
//
#include "stdafx.h"
#include "VIDCAP01.h"
#include "PropAdvanced.h"
#include "VAL_USB.h"
#include "usb_sdk definitions.h"
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CPropAdvanced property page

//IMPLEMENT_DYNCREATE(CPropAdvanced, CPropertyPage)

CPropAdvanced::CPropAdvanced() : CPropertyPage(CPropAdvanced::IDD)
{
	//{{AFX_DATA_INIT(CPropAdvanced)
	m_AdjustAperature = -1;
	m_AdjustSharpness = -1;
	m_Sharpness = 0;
	m_Aperature = 0;
	m_ZoomValue = 0;
	m_ExposureLevel = 0;
	//}}AFX_DATA_INIT
}

/*
CPropAdvanced::~CPropAdvanced()
{
}
*/

void CPropAdvanced::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPropAdvanced)
	DDX_Control(pDX, IDC_SLIDEREXPOSURE, m_SliderExposure);
	DDX_Control(pDX, IDC_SLIDERZOOM, m_SliderZoom);
	DDX_Control(pDX, IDC_SPINCAPTURESHARPNESS, m_CSpinCaptureSharpness);
	DDX_Control(pDX, IDC_SPINAPERATURE, m_CSpinAperature);
	DDX_Text(pDX, IDC_EDITSPINCAPTURESHARPNESS, m_Sharpness);
	DDX_Text(pDX, IDC_EDITSPINAPERATURE, m_Aperature);
	DDX_Text(pDX, IDC_EDITZOOMVALUE, m_ZoomValue);
	DDX_Text(pDX, IDC_EDITEXPOSURE, m_ExposureLevel);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CPropAdvanced, CPropertyPage)
	//{{AFX_MSG_MAP(CPropAdvanced)
	ON_WM_HSCROLL()	
	ON_BN_CLICKED(IDC_PAGEDEFAULTS, OnPagedefaults)
	ON_NOTIFY(UDN_DELTAPOS, IDC_SPINAPERATURE, OnDeltaposSpinaperature)
	ON_NOTIFY(UDN_DELTAPOS, IDC_SPINCAPTURESHARPNESS, OnDeltaposSpincapturesharpness)
	ON_BN_CLICKED(IDC_BUTTONREADZOOM, OnButtonreadzoom)
	ON_NOTIFY(NM_OUTOFMEMORY, IDC_SLIDEREXPOSURE, OnOutofmemorySlideresposure)
	ON_WM_CLOSE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPropAdvanced message handlers


BOOL CPropAdvanced::OnInitDialog() 
{
	CDialog::OnInitDialog();

	InitControls();
    m_bmpZoomIn.LoadBitmap( IDB_ZOOMINUSB);//ZOOMIN);
    m_bmpZoomOut.LoadBitmap( IDB_ZOOMOUTUSB);
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CPropAdvanced::InitControls()
{

m_CSpinCaptureSharpness.SetRange32(200,999);
m_CSpinAperature.SetRange32(0,4);

m_SliderZoom.SetRange(0, 16550);
ReadZoom();
m_SliderZoom.SetPos(m_ZoomValue);

m_SliderExposure.SetRange(0,15);
m_ExposureLevel=VALCam_Control(VC_ReadExposure,0,0,0,0);
m_SliderExposure.SetPos(m_ExposureLevel);
	
if ((m_pParent->m_Aperature <0) || (m_pParent->m_Aperature>4 )) 
	m_pParent->m_Aperature=3;

m_Aperature=m_pParent->m_Aperature;
m_Sharpness=m_pParent->m_Sharpness;

m_CSpinAperature.SetPos(m_pParent->m_Aperature);
m_CSpinCaptureSharpness.SetPos(m_pParent->m_Sharpness);

UpdateData(FALSE);
    
}


//*********** Control Zoom postion programatically**************************************************
void CPropAdvanced::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	 
	int value; 
	UpdateData(TRUE);
	if ((pScrollBar->GetDlgCtrlID())==IDC_SLIDERZOOM){
		value=m_SliderZoom.GetPos();
		VALCam_Control(VC_SetZoomPosition,value,0,0,0);	
		m_ZoomValue=value;
	 }
	 else 
		 if((pScrollBar->GetDlgCtrlID())==IDC_SLIDEREXPOSURE){
			 value=m_SliderExposure.GetPos();	
			 VALCam_Control(VC_SetExposure,value,0,0,0);
			 m_ExposureLevel=value;
		 }

	
	UpdateData(FALSE);
	CDialog::OnHScroll(nSBCode, nPos, pScrollBar);
}

void CPropAdvanced::PassPointer(CWnd * pnt)
{
 m_pParent=(CVIDCAP01Dlg*) pnt;
}



//************* Set "Sharpness" and "FGSharpness" ****************************************************
void CPropAdvanced::OnPagedefaults() 
{
 CString str;
 m_Sharpness=m_pParent->m_Sharpness=400; 
 m_Aperature=m_pParent->m_Aperature =3; ;
 VALCam_Control(VC_SetFrameGrabberSharpness ,m_Aperature,0,0,0);
 UpdateData(FALSE);

}


void CPropAdvanced::OnDeltaposSpinaperature(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_UPDOWN* pNMUpDown = (NM_UPDOWN*)pNMHDR;	
	if (pNMUpDown->iDelta==-1){
		(m_Aperature)--; 
		if (m_Aperature<0)  
			m_Aperature=0;
	}
	else{
		(m_Aperature) ++;
		if (m_Aperature >4) 
			m_Aperature =4;
	}
	
	m_pParent->m_Aperature=m_Aperature;
    VALCam_Control(VC_SetFrameGrabberSharpness ,(int)m_Aperature,0,0,0);
   	Sleep(20);
	UpdateData(FALSE);
	*pResult = 0;
}


void CPropAdvanced::OnDeltaposSpincapturesharpness(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_UPDOWN* pNMUpDown = (NM_UPDOWN*)pNMHDR;
	// TODO: Add your control notification handler code here
	//m_pParent->m_Aperature=m_CSpinCaptureSharpness.GetPos();//m_Aperature;
	
	if (pNMUpDown->iDelta==-1){
		(m_Sharpness)--; 
		if (m_Sharpness<0)  
			m_Sharpness=0;
	}
	else{
		(m_Sharpness) ++;
		if (m_Sharpness >999) 
			m_Sharpness =999;
	}

 	m_pParent->m_Sharpness =m_Sharpness;
	UpdateData(TRUE);
	*pResult = 0;
}


void CPropAdvanced::ReadZoom()
{
   
	//*************** Read Zoom Position***********************************
	m_ZoomValue=VALCam_Control(VC_ReadZoomPosition,0,0,0,0);
	UpdateData(FALSE);
}






void CPropAdvanced::OnButtonreadzoom() 
{
	ReadZoom();
	
}

void CPropAdvanced::OnOutofmemorySlideresposure(NMHDR* pNMHDR, LRESULT* pResult) 
{
	// TODO: Add your control notification handler code here
	
	*pResult = 0;
}

void CPropAdvanced::OnClose() 
{
	// TODO: Add your message handler code here and/or call default
	
	CPropertyPage::OnClose();
}
