// PropPageCrop.cpp : implementation file
//

#include "stdafx.h"
#include "VIDCAP01.h"
#include "PropPageCrop.h"
#include  "USB_SDK Definitions.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CPropPageCrop property page

IMPLEMENT_DYNCREATE(CPropPageCrop, CPropertyPage)

CPropPageCrop::CPropPageCrop() : CPropertyPage(CPropPageCrop::IDD)
{
	//{{AFX_DATA_INIT(CPropPageCrop)
	m_EnablePassWord = FALSE;
	m_CameraType = _T("");
	m_CropWidth = 0;
	m_CropHeight =0;
	m_CropStartX =0;
	m_CropStartY =0 ;
	m_ScaleX = 0;
	m_ScaleY = 0;
	//}}AFX_DATA_INIT
}

CPropPageCrop::~CPropPageCrop()
{
}

void CPropPageCrop::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPropPageCrop)
	DDX_Text(pDX, IDC_EDITCAMERATYPE, m_CameraType);
	DDX_Text(pDX, IDC_EDITCROPWIDTH, m_CropWidth);
	DDX_Text(pDX, IDC_EDITCROPHEIGHT, m_CropHeight);
	DDX_Text(pDX, IDC_EDITXCROPOFFSET, m_CropStartX);
	DDX_Text(pDX, IDC_EDITYCROPOFFSET, m_CropStartY);
	DDX_Text(pDX, IDC_EDITSCALEX, m_ScaleX);
	DDX_Text(pDX, IDC_EDITSCALEY, m_ScaleY);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CPropPageCrop, CPropertyPage)
	//{{AFX_MSG_MAP(CPropPageCrop)
	ON_BN_CLICKED(IDC_RESIZE, OnResize)
	ON_BN_CLICKED(IDC_BUTTONREDUCEDISPLAY, OnButtonreducedisplay)
	ON_BN_CLICKED(IDC_BUTTONDEFAULTCROPPINGVALUES, OnButtondefaultcroppingvalues)
	ON_EN_KILLFOCUS(IDC_EDITCROPWIDTH, OnKillfocusEditcropwidth)
	ON_EN_KILLFOCUS(IDC_EDITCROPHEIGHT, OnKillfocusEditcropheight)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPropPageCrop message handlers

void CPropPageCrop::PassPointer(CWnd *pnt)
{
 m_pParent=(CVIDCAP01Dlg*) pnt;
}
  
	
BOOL CPropPageCrop::OnInitDialog() 
{
	CPropertyPage::OnInitDialog();
	
	// TODO: Add extra initialization here
   
m_CropStartX=m_pParent->m_CropStartX;
m_CropStartY=m_pParent->m_CropStartY;
m_CropWidth=m_pParent->m_CropWidth;
m_CropHeight=m_pParent->m_CropHeight;
m_ScaleX=m_pParent->m_ScaleX;
m_ScaleY=m_pParent->m_ScaleY;
	
switch (m_pParent->m_CameraType){
	case 1:m_CameraType="PTZ Rev1";
		   break;

	case 3:m_CameraType="Zoom Rev 2";
		   break;
	
	case 4:m_CameraType="PTZ Rev 2";
		   break;

	case 5:m_CameraType="PTZ Rev 3";
		   break;
	
	default:m_CameraType="Other";
		   break;
	}
	
UpdateData(FALSE);
return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}


void CPropPageCrop::OnResize() 
{
	// TODO: Add your control notification handler code here
UpdateData(TRUE);

m_pParent->m_CropWidth=m_CropWidth;//atoi(m_EditHorz);
m_pParent->m_CropHeight=m_CropHeight;//atoi(m_EditVertical);	
m_pParent->m_CropStartX=m_CropStartX;
m_pParent->m_CropStartY=m_CropStartY;
m_pParent->m_ScaleX=m_ScaleX;
m_pParent->m_ScaleY=m_ScaleY;
   	
int err=VALCam_Control(VC_SetCropParameters,m_CropStartX,m_CropStartY,m_CropWidth,m_CropHeight);
if (err<1)
	MessageBox("Parameters out of Range","Error in SetCrop Command",0);
	
else{
	VALCam_Control(VC_DisplayVideo,0,0,m_ScaleX,m_ScaleY);
	m_pParent->ResizeMainWindow();
	if (m_CropWidth/m_CropHeight != m_ScaleX/m_ScaleY) 
		MessageBox("Aspect Ratio Not Valid","Warning",0);
	}
	
}


void CPropPageCrop::OnButtonreducedisplay() 
{
  VALCam_Control(VC_DisplayVideo,0,0,m_CropWidth/2,m_CropHeight/2);
	
}

void CPropPageCrop::OnButtondefaultcroppingvalues() 
{
m_pParent->m_CropWidth=m_CropWidth=625;//atoi(m_EditHorz);
m_pParent->m_CropHeight=m_CropHeight=477;//atoi(m_EditVertical);	
m_pParent->m_CropStartX=m_CropStartX=5;
m_pParent->m_CropStartY=m_CropStartY=3;
m_pParent->m_ScaleX=m_ScaleX=625;
m_pParent->m_ScaleY=m_ScaleY=477;

//******************************* Set Cropping Parameters************************************************	
int err=VALCam_Control(VC_SetCropParameters,m_CropStartX,m_CropStartY,m_CropWidth,m_CropHeight);
if (err<1)
		MessageBox("Parameters out of Range","Error in SetCrop Command",0);
	
else{
	    // ******* Display Live Video*****************************************
	    VALCam_Control(VC_DisplayVideo,0,0,m_CropWidth,m_CropHeight);
		m_pParent->ResizeMainWindow();	
	    UpdateData(FALSE);
	}
}


// ***************************Force m_ScaleX to follow m_CropWidth to avoid confusion**************
void CPropPageCrop::OnKillfocusEditcropwidth() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	m_ScaleX=m_CropWidth;
	UpdateData(FALSE);
}

//****************************Force m_ScaleY to follow m_CropHeight to avoid confusion**************
void CPropPageCrop::OnKillfocusEditcropheight() 
{
	UpdateData(TRUE);
	m_ScaleY=m_CropHeight;
	UpdateData(FALSE);
}
