
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////


#include "stdafx.h"
#include "VIDCAP01.h"
#include "VIDCAP01Dlg.h"
#include "VAL_USB.h"
#include "PropAdjust.h"
#include "PropAdvanced.h"
#include "MyPropSheet.h"
//#include "PropertyPageDebug.h"
#include "PropPageCrop.h"
#include "Pass.h"
#include "AutoPosition.h"
#include "CMouseCapture1.h"
#include "Direct.h"
// ******* Definitions for VALCam USB SDK Commands and exported DLL*********************************
#include  "USB_SDK Definitions.h"  
//**************************************************************************************
CCMouseCapture1 CMouseCapture1;
CVIDCAP01Dlg *ThisPtr;
CPropAdjust *page1;
CPropAdvanced *page2;
CPropPageCrop      *page4;
CAutoPosition      *page5;

//********************** Contains Captured DIB ******************************************
HANDLE DIB_Image_Handle;


/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	void SetControls();
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CVIDCAP01Dlg dialog

CVIDCAP01Dlg::CVIDCAP01Dlg(CWnd* pParent /*=NULL*/)
	: CDialog(CVIDCAP01Dlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CVIDCAP01Dlg)
	m_PreviewCapture = 1;
	m_FlashCapture = 0;
	m_MouseX = 0;
	m_MouseY = 0;
	m_ColorAdjustVisible=FALSE;
	m_KeyCount=0;
	m_SetAutoPositionOffset=FALSE;
	m_FlashIrisLevelstr = _T("");
	m_YCenterOffset=0;;
	m_XCenterOffset=0;
	m_TiltReverse=FALSE;
	m_PanReverse=FALSE;
	m_ColorCorrectionLock=FALSE;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CVIDCAP01Dlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CVIDCAP01Dlg)
	DDX_Control(pDX, IDC_EDITREDCOLOR, m_EditColorRed);
	DDX_Control(pDX, IDC_EDITBLUECOLOR, m_EditColorBlue);
	DDX_Control(pDX, IDC_SLIDERBLUE, m_SliderBlue);
	DDX_Radio(pDX, IDC_PREVIEWNO, m_PreviewCapture);
	DDX_Radio(pDX, IDC_USEFLASHNO, m_FlashCapture);
	DDX_Control(pDX, IDC_SLIDERRED, m_SliderRed);
	DDX_Text(pDX, IDC_EDITFLASHIRIS, m_FlashIrisLevelstr);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CVIDCAP01Dlg, CDialog)
	//{{AFX_MSG_MAP(CVIDCAP01Dlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_BN_CLICKED(IDC_CAPTURE, OnCapture)
	ON_WM_CLOSE()
	ON_BN_CLICKED(IDC_IRISDOWN, OnIrisdown)
	ON_BN_CLICKED(IDC_IRISUP, OnIrisup)
	ON_WM_SETCURSOR()
	ON_BN_CLICKED(IDC_DONTSAVE, OnDontsave)
	ON_BN_CLICKED(IDC_SAVE, OnSave)
	ON_BN_CLICKED(IDC_USEFLASHNO, OnUseflashno)
	ON_BN_CLICKED(IDC_USEFLASHYES, OnUseflashyes)
	ON_BN_CLICKED(IDC_ADJUST, OnAdjust)
	ON_BN_CLICKED(IDC_PREVIEWNO, OnPreviewno)
	ON_BN_CLICKED(IDC_PREVIEWYES, OnPreviewyes)
	ON_WM_VSCROLL()
	ON_BN_CLICKED(IDC_BUTTONDEFAULT, OnButtondefault)
	ON_BN_CLICKED(IDC_CAPTURE, OnCapture)
	ON_WM_HSCROLL()
	ON_WM_KEYUP()
	ON_BN_CLICKED(IDC_BUTTONHOME, OnButtonhome)
	ON_WM_LBUTTONDBLCLK()
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONUP()
	//}}AFX_MSG_MAP
	
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CVIDCAP01Dlg message handlers

BOOL CVIDCAP01Dlg::OnInitDialog()
{
   
	CDialog::OnInitDialog();
	m_RightMouseDown=FALSE;
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);
	Control=Shift=Up=Down=Left=Right=Add=Subtract=FALSE;

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
    
	//*************** Initializes DLL and Camera. Reads INI file ******************************
	//*************** This must be first command issued **************************************
	m_CameraType=VALCam_Control(VC_InitSystem,(int)m_hWnd,0,0,0);	
    
	//************************* Error in Initialization********************************
	if (m_CameraType<1){
		MessageBox("Error in VC_InitSystem, Quiting Application");
		exit(1);
	}
	    
	//***************** Retrieves Parameters read by DLL from "VALCam USB SDK.ini" 
	
	//***************** Read SDK Ini returned from SDK ************************************
	Read_Ini_Values();
	
	//************ Passes Window Handle to Display Live Video***********************************
   // VALCam_Control(VC_SendWindowHandle,(int)m_hWnd,0,0,0);
	
	RECT rect;
	rect.top=0;
	rect.left=0;
	rect.bottom=480;
	rect.right=640;
	int error=0;
	
	 //**** Create Window used to detect Message to Live Display Window******
	 //**** This Window is used to AutoPositioning 
	 //**** This only needs to be done to detech Messages on live display window
	 //Removed 1-12-11 
	/*
	error=CMouseCapture1.Create(AfxRegisterWndClass(CS_DBLCLKS,0,0,0),"MC",WS_CHILD | WS_VISIBLE,
						rect,this, 76);
	 CMouseCapture1.Ptr=this;
	 */ 
	 //*********************************************************************
	 
	 // ************Sends Window Handle of window used to detect messages of Live Diplay**************
	 // ************ The Live Display will respond to Window Messages (mouse clicks)******************
	 //*************This allows the live display to responde to mouse clicke for AutoPositioning Feature*********
	 //VALCam_Control(VC_MessageDrainHnd,(int)CMouseCapture1.m_hWnd,0,0,0);
     //**********************************************************************************************

     m_SliderRed.SetRange(-50,50,TRUE);
	 m_SliderBlue.SetRange (-50,50,TRUE);
	 m_SliderRed.SetPos (0);
	 m_SliderBlue.SetPos(0);
    
	
	PropSheet=new CMyPropSheet("TEST"); //Create Property Sheet of Dialog
	PrepareBitmaps(); //Paint Bitmaps on Pan/Tilt/Zoom/Iris Buttons
//	SetControlParameters();
	ResizeMainWindow();

	//*********************Starts Live Display at 0,0 and scaled to m_CropWidth, and m_CropHeight
	VALCam_Control(VC_DisplayVideo,0,0,m_CropWidth,m_CropHeight);
    //********************************************************************************************
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CVIDCAP01Dlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CVIDCAP01Dlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.


void CVIDCAP01Dlg::OnClose() 
{
	//************ This call must be used before closing app!!!!!!****************************************
	//*** Closes DLL and releases all resources. 
	//****Ini file is updated
	//*** DLL cannot be used again until VC_InitSystem is called 
	VALCam_Control(VC_CloseCard,0,0,0,0);
	
	CDialog::OnClose();
}



void CVIDCAP01Dlg::OnIrisdown() 
{
	// TODO: Add your control notification handler code here
    
	if (m_FlashCapture) {
		if  (m_FlashIrisLevel<0) m_FlashIrisLevel=0;
		m_FlashIrisLevel --;
		if (m_FlashIrisLevel <0) m_FlashIrisLevel=0;
		
		//*****Decreases FlashIris Setting,no change in live display
		VALCam_Control(VC_SetFlashIrisLevel,m_FlashIrisLevel,0,0,0);	
		//**********************************************************
		
		//********************** Converts to Flash Iris Level to suggested distances***********************
		FlashIrisLevelDistance();		
		//*************************************************************************************************
	}
	else
		//****Decreases Live Iris Setting,changes in live display********
		VALCam_Control(VC_LiveIrisDown,0,0,0,0);
           
	//****************************************************************
}

void CVIDCAP01Dlg::OnIrisup() 
{
	// TODO: Add your control notification handler code here
    
	if (m_FlashCapture) {
		if  (m_FlashIrisLevel<0) m_FlashIrisLevel=0;
		m_FlashIrisLevel ++;
		if (m_FlashIrisLevel >32) m_FlashIrisLevel=32;
		
		//*****Increases FlashIris Setting,no change in live display*******
		VALCam_Control(VC_SetFlashIrisLevel,m_FlashIrisLevel,0,0,0);	
		//****************************************************************
		
		//********************** Converts to Flash Iris Level to suggested distances***********************
		FlashIrisLevelDistance();
		//*************************************************************************************************
	}
   else
	   	//****Increases Live Iris Setting,changes in live display
	   VALCam_Control(VC_LiveIrisUp,0,0,0,0);
        
   UpdateData(FALSE);
}


void CVIDCAP01Dlg::OnCapture() 
{
	int DIB=0,DDB=1,Clipboard=2,BMP=3, JPG=25;
	
	if (m_FlashCapture==1) //Use Flash
	  if (m_PreviewCapture==1)	 
		//***************************** Flash Capture with preview saved to clipboard ********************
		DIB_Image_Handle=(HANDLE)VALCam_Control(VC_FlashCapture,m_Sharpness,1,0,Clipboard);//Preview Flash Capture
	  else
        //************ Capture immediate, no preview *********************************************
		  DIB_Image_Handle=(HANDLE)VALCam_Control(VC_FlashCapture,m_Sharpness,0,0,Clipboard);
	else
       if (m_PreviewCapture==1)	 
		//***************************** Live Capture with preview saved to clipboard ********************
		DIB_Image_Handle=(HANDLE)VALCam_Control(VC_LiveCapture,m_Sharpness,1,0,Clipboard); //Preview Live Capture
	  else
        //************ Capture immediate, no preview *********************************************
		DIB_Image_Handle=(HANDLE)VALCam_Control(VC_LiveCapture,m_Sharpness,0,0,Clipboard); 
			
	if (m_PreviewCapture==TRUE){
	 //*****************Makes Live Display Invisible******************
	 VALCam_Control(VC_Freeze,0,0,0,0); 
	 //************************* Displays Captured Image**************************************
	 VALCam_Control(VC_DisplayCapture,(int)m_hWnd,0,0,0);
	 SetPreviewInterface();
	}
}

////**********************************************************************************************
////********************** This Routine detects Mouse Down events for Pan/Tilt/Zoom***************
////**********************************************************************************************

BOOL CVIDCAP01Dlg::OnSetCursor(CWnd* pWnd, UINT nHitTest, UINT message) 
{
	// TODO: Add your message handler code here and/or call default
    
	
	
	if (pWnd== GetDlgItem(IDC_ZOOMIN)){
		if (message==WM_LBUTTONDOWN){
			
			if (!(m_ZoomActive)){   //(!(m_ZoomActive))
				if (Control==TRUE){
					VALCam_Control(VC_ZoomInFast,0,0,0,0); 
					m_AutoZoomGood=FALSE;
					m_ZoomActive=1;
					return 1;
				}
				
				if (Shift==TRUE){
					VALCam_Control(VC_ZoomInSlow,0,0,0,0); 
					m_ZoomActive=1;
					return 1;
				}

				switch(m_PTZSpeed){
				case 0: 
					VALCam_Control(VC_ZoomInSlow,0,0,0,0); 
					break;
                
				case 1: 
					VALCam_Control(VC_ZoomIn,0,0,0,0); 
					m_AutoZoomGood=FALSE;
					break;
                
				case 2:
					VALCam_Control(VC_ZoomInFast,0,0,0,0); 
					m_AutoZoomGood=FALSE;
					break; 

                default: 
					
					VALCam_Control(VC_ZoomIn,0,0,0,0); 
					m_AutoZoomGood=FALSE;
					break;
				}			
			    m_ZoomActive=1;
			 
			}
			 return(1);
		}
	     if (message==WM_MOUSEMOVE){
			 if (m_ZoomActive){
			     
				 m_ZoomActive=0;
			     Sleep(75);
				 
			     VALCam_Control(VC_ZoomStop,0,0,0,0); 
			 }
			return(1);
		}
	}

	if (pWnd== GetDlgItem(IDC_ZOOMOUT)){
		if (message==WM_LBUTTONDOWN){
			
			if (m_LockZoom==TRUE){
			
				MessageBox("Zoom is locked. See administrator.","Zoom Locked",0);
				return 1; 		
			}
											
			if (!(m_ZoomActive)){
			
			 if (Control==TRUE){
					
					VALCam_Control(VC_ZoomOutFast,0,0,0,0); 
				    m_ZoomActive=1;
					m_AutoZoomGood=FALSE;
					return 1;
				}
				
				if (Shift==TRUE){
					
					VALCam_Control(VC_ZoomOutSlow,0,0,0,0); 
					m_ZoomActive=1;
					return 1;
				}	
				
				
				switch(m_PTZSpeed){
				case 0: 
					
					VALCam_Control(VC_ZoomOutSlow,0,0,0,0); 
					m_AutoZoomGood=FALSE;
					break;
                
				case 1: 
					
					VALCam_Control(VC_ZoomOut,0,0,0,0); 
					m_AutoZoomGood=FALSE;
					break;
                
				case 2: 
					
					VALCam_Control(VC_ZoomOutFast,0,0,0,0); 
					m_AutoZoomGood=FALSE;
					break; 

                default: 
					
					VALCam_Control(VC_ZoomOut,0,0,0,0); 
					m_AutoZoomGood=FALSE;
					break;
			} 
			    m_ZoomActive=1;
			
			}
			return(1); 
		}
	     if (message==WM_MOUSEMOVE){
			 if (m_ZoomActive){
				 Sleep(75);
				 m_ZoomActive=0;
			     
				 VALCam_Control(VC_ZoomStop,0,0,0,0); 
			 }
			return(1);			 
		}
	}
		
	
	if (pWnd== GetDlgItem(IDC_TILTUP)){
		if (message==WM_LBUTTONDOWN){
			if (!(m_ZoomActive)){
                 Up=TRUE;
				if (Control==TRUE){
					if (m_TiltReverse==TRUE)
				
		 			    VALCam_Control(VC_TiltDownFast,0,0,0,0); 
					else
                
						VALCam_Control(VC_TiltUpFast,0,0,0,0); 
					m_ZoomActive=1;
					return 1;
				}				
				if (Shift==TRUE){
					if (m_TiltReverse==TRUE)
				
					  VALCam_Control(VC_TiltDownSlow,0,0,0,0); 
					else
                
					  VALCam_Control(VC_TiltUpSlow,0,0,0,0); 
					m_ZoomActive=1;
					return 1;
				}			  
			
				switch(m_PTZSpeed){
				case 0: 
					if (m_TiltReverse==TRUE)
				
					 VALCam_Control(VC_TiltDownSlow,0,0,0,0); 
					else
				
					 VALCam_Control(VC_TiltUpSlow,0,0,0,0); 
					break;
                
				case 1: 
					if (m_CameraType>=4){
					 if (m_TiltReverse==TRUE)
				
						VALCam_Control(VC_TiltDown,0,0,0,0); 
					 else
				
						VALCam_Control(VC_TiltUp,0,0,0,0); 
					}
					else if (m_CameraType<3){
						     if (m_TiltReverse==TRUE)
				
							   VALCam_Control(VC_TiltDownSlow,0,0,0,0); 
					        else
				
							   VALCam_Control(VC_TiltUpSlow,0,0,0,0); 
					}
					break;
                
				case 2: 
				    if (m_CameraType>=4){
						if (m_TiltReverse==TRUE)
				
						VALCam_Control(VC_TiltDownFast,0,0,0,0); 
					 else
				
						VALCam_Control(VC_TiltUpFast,0,0,0,0); 
					}
					else if (m_CameraType<3){
						if (m_TiltReverse==TRUE)
				
						  VALCam_Control(VC_TiltDown,0,0,0,0); 
					     else
				
						  VALCam_Control(VC_TiltUp,0,0,0,0); 
					}
					break; 

                default: 
					if (m_CameraType>=4){
						if (m_TiltReverse==TRUE)
				
						  VALCam_Control(VC_TiltDown,0,0,0,0); 
					    else
				
						  VALCam_Control(VC_TiltUp,0,0,0,0); 
					}
					else 
					if (m_CameraType<3){
						if (m_TiltReverse==TRUE)
				
						  VALCam_Control(VC_TiltDownSlow,0,0,0,0); 
					    else
				
						  VALCam_Control(VC_TiltUpSlow,0,0,0,0); 
					}
					break;
			}  			   
			   

				
			    m_ZoomActive=1;
			 
			}
			 return(1);
		}
		if (message==WM_MOUSEMOVE){
			 if (m_ZoomActive){
				 Up=FALSE;
				 Sleep(75);
				 m_ZoomActive=0;
			    
				 VALCam_Control(VC_PanTiltStop,0,0,0,0); 
			 
			 }
			return(1);
		}
	}
       
    if (pWnd== GetDlgItem(IDC_TILTDOWN)){
		if (message==WM_LBUTTONDOWN){
			if(!(m_ZoomActive)){
			   Down=TRUE; 
               if (Control==TRUE){
				if (m_TiltReverse==TRUE)
				
				   VALCam_Control(VC_TiltUpFast,0,0,0,0); 
				else
				
					VALCam_Control(VC_TiltDownFast,0,0,0,0); 
				m_ZoomActive=1;
				return 1;
				}
				
				if (Shift==TRUE){
					if (m_TiltReverse==TRUE)
				
					 VALCam_Control(VC_TiltUpSlow,0,0,0,0); 
				    else
				
					 VALCam_Control(VC_TiltDownSlow,0,0,0,0); 
				
				m_ZoomActive=1;
				return 1;
				}				
				
				switch(m_PTZSpeed){
				case 0: 
				 if (m_TiltReverse==TRUE)
				
				   VALCam_Control(VC_TiltUpSlow,0,0,0,0); 
				 else
				
				   VALCam_Control(VC_TiltDownSlow,0,0,0,0); 
					break;
                
				case 1: 
					if (m_CameraType>=4){
					  if (m_TiltReverse==TRUE)
				
						VALCam_Control(VC_TiltUp,0,0,0,0); 
				      else
				
						VALCam_Control(VC_TiltDown,0,0,0,0); 
					}
					else if (m_CameraType<3){
				      if (m_TiltReverse==TRUE)
				
						 VALCam_Control(VC_TiltUpSlow,0,0,0,0); 
				      else
				
						 VALCam_Control(VC_TiltDownSlow,0,0,0,0); 
					}
					break;
                
				case 2: 
				    if (m_CameraType>=4){
					  if (m_TiltReverse==TRUE)
				
						VALCam_Control(VC_TiltUpFast,0,0,0,0); 
				      else
				
						VALCam_Control(VC_TiltDownFast,0,0,0,0); 
					}
					else if (m_CameraType<3){
					  if (m_TiltReverse==TRUE)
				
						VALCam_Control(VC_TiltUp,0,0,0,0); 
				      else
				
						VALCam_Control(VC_TiltDown,0,0,0,0); 
					}
					break; 

                default: 
					if (m_CameraType>=4){
					  if (m_TiltReverse==TRUE)
				
						VALCam_Control(VC_TiltUp,0,0,0,0); 
				      else
				
						VALCam_Control(VC_TiltDown,0,0,0,0); 
					}
					else if (m_CameraType<3){
				      if (m_TiltReverse==TRUE)
				
						VALCam_Control(VC_TiltUpSlow,0,0,0,0); 
				      else
				
					    VALCam_Control(VC_TiltDownSlow,0,0,0,0); 
				
					}			    
			  }
			  }
			 m_ZoomActive=1;
			  return(1);
		}
		if (message==WM_MOUSEMOVE){
			 if (m_ZoomActive){			    
				 Sleep(75);
				 Down=FALSE;
				 m_ZoomActive=0;
			    
				 VALCam_Control(VC_PanTiltStop,0,0,0,0); 
			 }
			return(1);
		}
		}		
	
	 if (pWnd== GetDlgItem(IDC_PANLEFT)){
		if (message==WM_LBUTTONDOWN){
			if (!(m_ZoomActive)){
			    Left=TRUE;
				if (Control==TRUE){
				 if (m_PanReverse==TRUE)	
				
					VALCam_Control(VC_PanLeftFast,0,0,0,0); 
				 else	
				
					VALCam_Control(VC_PanRightFast,0,0,0,0); 
				 m_ZoomActive=1;
					return 1;
				}
				
				if (Shift==TRUE){
				  if (m_PanReverse==TRUE)	
				
					VALCam_Control(VC_PanLeftSlow,0,0,0,0); 
				 else	
				
					VALCam_Control(VC_PanRightSlow,0,0,0,0); 
					m_ZoomActive=1;
					return 1;
				}
				
				switch(m_PTZSpeed){
				case 0: 
				  if (m_PanReverse==TRUE)	
				
					VALCam_Control(VC_PanLeftSlow,0,0,0,0); 
				 else	
				
					VALCam_Control(VC_PanRightSlow,0,0,0,0); 
					break;
                
				case 1: 
					if (m_CameraType>=4){
					  if (m_PanReverse==TRUE)	
				
						 VALCam_Control(VC_PanLeft,0,0,0,0); 
				      else	
				
						 VALCam_Control(VC_PanRight,0,0,0,0); 
					}
					else if (m_CameraType<3){
					  if (m_PanReverse==TRUE)	
				
						 VALCam_Control(VC_PanLeftSlow,0,0,0,0); 
				      else	
				
						 VALCam_Control(VC_PanRightSlow,0,0,0,0); 
					}
					break;
                
				case 2: 
				    if (m_CameraType>=4){
					  if (m_PanReverse==TRUE)	
				
						 VALCam_Control(VC_PanLeftFast,0,0,0,0); 
				      else	
				
						 VALCam_Control(VC_PanRightFast,0,0,0,0); 
					}
					else if (m_CameraType<3){
					  if (m_PanReverse==TRUE)	
				
						 VALCam_Control(VC_PanLeft,0,0,0,0); 
				      else	
				
						 VALCam_Control(VC_PanRight,0,0,0,0); 
					}
					break; 

                default: 
					if (m_CameraType>=4){
					  if (m_PanReverse==TRUE)	
				
						 VALCam_Control(VC_PanLeft,0,0,0,0); 
				      else	
				
						 VALCam_Control(VC_PanRight,0,0,0,0); 
				      
					}
					else if (m_CameraType<3){
					  if (m_PanReverse==TRUE)	 	     
				
						VALCam_Control(VC_PanLeftSlow,0,0,0,0); 
					  else
                
						VALCam_Control(VC_PanRightFast,0,0,0,0); 
					}			    			 
			}
				
			m_ZoomActive=1;    
			 
			}
			 return(1);
		}
		if (message==WM_MOUSEMOVE){
			 if (m_ZoomActive){			    
				 Sleep(75);
				 Left=FALSE;
				 m_ZoomActive=0;
			    
				 VALCam_Control(VC_PanTiltStop,0,0,0,0); 
			 
			 }
			return(1);
		}
	}	
	

     if (pWnd== GetDlgItem(IDC_PANRIGHT)){
		if (message==WM_LBUTTONDOWN){
			if(!(m_ZoomActive)){
			  Right=TRUE;
			  if (Control==TRUE){
				 if (m_PanReverse==TRUE)		
				
			       VALCam_Control(VC_PanRightFast,0,0,0,0); 
				 else
				
				   VALCam_Control(VC_PanLeftFast,0,0,0,0); 
	    	  m_ZoomActive=1;
					return 1;
				}
				
				if (Shift==TRUE){
					if (m_PanReverse==TRUE)	
				
						 VALCam_Control(VC_PanRightSlow,0,0,0,0); 
				     else	
				
					     VALCam_Control(VC_PanLeftSlow,0,0,0,0); 
					
					m_ZoomActive=1;
					return 1;
				}	
				switch(m_PTZSpeed){
				case 0: 
				  if (m_PanReverse==TRUE)	
				
						 VALCam_Control(VC_PanRightSlow,0,0,0,0); 
				     else	
				
	                     VALCam_Control(VC_PanLeftSlow,0,0,0,0); 
					break;
                
				case 1: 
					if (m_CameraType>=4){
					  if (m_PanReverse==TRUE)	
				
						 VALCam_Control(VC_PanRight,0,0,0,0); 
				     else	
			
						 VALCam_Control(VC_PanLeft,0,0,0,0); 
	
					}
					else 
					if (m_CameraType<3){
					  if (m_PanReverse==TRUE)	
			
						 VALCam_Control(VC_PanRightSlow,0,0,0,0); 
				     else	
			
						 VALCam_Control(VC_PanLeftSlow,0,0,0,0); 
					}
					break;
                
				case 2: 
				    if (m_CameraType>=4){
					  if (m_PanReverse==TRUE)	
			
						 VALCam_Control(VC_PanRightFast,0,0,0,0); 
				     else	
			
					     VALCam_Control(VC_PanLeftFast,0,0,0,0); 
					}
					else if (m_CameraType<3){
						   if (m_PanReverse==TRUE)	
			
						 VALCam_Control(VC_PanRight,0,0,0,0); 
				     else	
			
						 VALCam_Control(VC_PanLeft,0,0,0,0); 
					}
					break; 

                default: 
					if (m_CameraType>=4){
					  if (m_PanReverse==TRUE)	
			
						 VALCam_Control(VC_PanRight,0,0,0,0); 
				     else	
			
						 VALCam_Control(VC_PanLeft,0,0,0,0); 
					}
					else 
					if (m_CameraType<3){
					  if (m_PanReverse==TRUE)	
			
						 VALCam_Control(VC_PanRightSlow,0,0,0,0); 
				     else	
			
					     VALCam_Control(VC_PanLeftSlow,0,0,0,0); }			    			 
			  }	  
		
			m_ZoomActive=1;    				
			}
			 return(1);
		}
		if (message==WM_MOUSEMOVE){
			 if (m_ZoomActive){			   
				 Sleep(75);
				 Right=FALSE;
				 m_ZoomActive=0;
			
			     VALCam_Control(VC_PanTiltStop,0,0,0,0); 
			 }
			return(1);
		}
	}	
	
	
	 
           if(m_ZoomActive)
		   {	
		    
			  VALCam_Control(VC_ZoomStop,0,0,0,0); 
             Sleep(100);
			
			 VALCam_Control(VC_PanTiltStop,0,0,0,0); 
		     m_ZoomActive=0;
		     m_KeyCount=0;
	      return CDialog::OnSetCursor(pWnd, nHitTest, message);
	}
	 
        		
		   DWORD dwPos=::GetMessagePos ();
		   CPoint point (LOWORD (dwPos),HIWORD (dwPos));
		   ScreenToClient(&point);
		   CRect rect;
		   GetClientRect(&rect);
		   
	return CDialog::OnSetCursor(pWnd, nHitTest, message);
}


void CVIDCAP01Dlg::SetControlParameters()
{

	//*************** Positions Capture Button under Live Video Display**************************
	GetDlgItem(IDC_CAPTURE)->MoveWindow(  0,  482, 640, 25, TRUE );
  
}

//*******************************************************************************************
//**************** This Routine sets the preview dialog controls ******************************

void CVIDCAP01Dlg::SetPreviewInterface()
{
CWnd* pCWnd;

GetDlgItem(IDC_USEFLASHNO)->EnableWindow(FALSE);
GetDlgItem(IDC_USEFLASHYES)->EnableWindow(FALSE);


pCWnd=GetDlgItem(IDC_DONTSAVE);
GetDlgItem(IDC_CAPTURE)->ShowWindow(SW_HIDE);
pCWnd->MoveWindow(m_CropWidth/2,  m_CropHeight, m_CropWidth/2, 25, TRUE );
pCWnd->ShowWindow(SW_SHOW);

pCWnd=GetDlgItem(IDC_SAVE);
//pCWnd->MoveWindow(0,  480, 320, 25, TRUE );
pCWnd->MoveWindow(0,  m_CropHeight, m_CropWidth/2, 25, TRUE );
pCWnd->ShowWindow(SW_SHOW);

Make_Interface_Visible(FALSE);

/**************** Code used to Display a DIB
PBITMAPINFO lpBitmapInfo=(PBITMAPINFO)GlobalLock(DIB_Image_Handle);
char * lpBits=(char *)lpBitmapInfo +  lpBitmapInfo->bmiHeader.biSize;;
HDC hDC;
hDC=::GetDC(m_hWnd);      
    
SetDIBitsToDevice(hDC,0,0,
				  lpBitmapInfo->bmiHeader.biWidth,
	              lpBitmapInfo->bmiHeader.biHeight,
				  0,0,0,lpBitmapInfo->bmiHeader.biHeight,
	              lpBits,lpBitmapInfo,
				  DIB_RGB_COLORS);
                 
::ReleaseDC(m_hWnd,hDC);
**********************************************/	   
}

void CVIDCAP01Dlg::OnDontsave() 
{
//*********** Free memory used for DIB**************************
//GlobalUnlock(DIB_Image_Handle);
//GlobalFree(DIB_Image_Handle);

//****************** Discard Preview Image. Memory Freeded.  ***************************
//****************** Image must be saved or discarded but capturing another image ******
VALCam_Control(VC_DiscardCapturedImage,0,0,0,0);
			   
GetDlgItem(IDC_DONTSAVE)->ShowWindow(SW_HIDE); //Activate Capture button
GetDlgItem(IDC_SAVE)->ShowWindow(SW_HIDE);
GetDlgItem(IDC_CAPTURE)->ShowWindow(SW_SHOW);

GetDlgItem(IDC_USEFLASHNO)->EnableWindow(TRUE);
GetDlgItem(IDC_USEFLASHYES)->EnableWindow(TRUE);
GetDlgItem(IDC_CAPTURE)->EnableWindow(TRUE);

Make_Interface_Visible(TRUE);
RedrawWindow();
}



void CVIDCAP01Dlg::OnSave() 
{   

//****************** Save Captured Image *************************************************
//**** The image is saved according to Param4  of the VC_LiveCapture or VC_FlashCapture command************
VALCam_Control(VC_SaveCapturedImage,0,0,0,0);

GetDlgItem(IDC_DONTSAVE)->ShowWindow(SW_HIDE); //Activate Capture button
GetDlgItem(IDC_SAVE)->ShowWindow(SW_HIDE);
GetDlgItem(IDC_CAPTURE)->ShowWindow(SW_SHOW);

GetDlgItem(IDC_USEFLASHNO)->EnableWindow(TRUE);
GetDlgItem(IDC_USEFLASHYES)->EnableWindow(TRUE);
GetDlgItem(IDC_CAPTURE)->EnableWindow(TRUE);
Make_Interface_Visible(TRUE);

}


void CVIDCAP01Dlg::OnUseflashno() 
{

	// TODO: Add your control notification handler code here
	UpdateData();
	::SetFocus(::GetDlgItem(m_hWnd,IDC_TILTUP));
	HWND hwnd =PropSheet->GetSafeHwnd();
    GetDlgItem(IDC_STATICBRIGHTNESS)->SetWindowText("Live Brightness");
	m_FlashIrisLevelstr="NA";
	UpdateData(FALSE);	
}
	
	


void CVIDCAP01Dlg::OnUseflashyes() 
{
	CString str;
	UpdateData();
	::SetFocus(::GetDlgItem(m_hWnd,IDC_TILTUP));
	HWND hwnd =PropSheet->GetSafeHwnd();
    GetDlgItem(IDC_STATICBRIGHTNESS)->SetWindowText("Flash Brightness");;
	str.Format("%d",m_FlashIrisLevel);
    FlashIrisLevelDistance();
    UpdateData(FALSE);		
}



//**************************** Process Bitmaps for button controls***************************************
void CVIDCAP01Dlg::PrepareBitmaps()
{
    CButton*  ptrButton;

	m_bmpZoomIn.LoadBitmap( IDB_ZOOMINUSB);
    m_bmpZoomOut.LoadBitmap( IDB_ZOOMOUTUSB);	
	m_bmpTiltDown.LoadBitmap( IDB_TILTDOWNDOWN);	
	m_bmpTiltUp.LoadBitmap(IDB_TILTUPDOWN1);
	m_bmpPanLeft.LoadBitmap( IDB_PANLEFT);
	m_bmpPanRight.LoadBitmap( IDB_PANRIGHT);
	m_bmpIrisUp.LoadBitmap( IDB_IRISUP);
	m_bmpIrisDown.LoadBitmap( IDB_IRISDOWNUSB1);
	
	
	ptrButton=(CButton*) GetDlgItem(IDC_ZOOMIN);
    ptrButton ->SetBitmap(m_bmpZoomIn);

	ptrButton=(CButton*) GetDlgItem(IDC_ZOOMOUT);
    ptrButton ->SetBitmap(m_bmpZoomOut);

	ptrButton=(CButton*) GetDlgItem(IDC_TILTUP);
    ptrButton ->SetBitmap(m_bmpTiltUp);

	ptrButton=(CButton*) GetDlgItem(IDC_TILTDOWN);
    ptrButton ->SetBitmap(m_bmpTiltDown);

	ptrButton=(CButton*) GetDlgItem(IDC_PANRIGHT);
    ptrButton ->SetBitmap(m_bmpPanRight);

	ptrButton=(CButton*) GetDlgItem(IDC_PANLEFT);
    ptrButton ->SetBitmap(m_bmpPanLeft);

	ptrButton=(CButton*) GetDlgItem(IDC_IRISUP);
    ptrButton ->SetBitmap(m_bmpIrisUp);

    ptrButton=(CButton*) GetDlgItem(IDC_IRISDOWN);
    ptrButton ->SetBitmap(m_bmpIrisDown);


}

// ***** Create and open Adjust Dialog Box*********************************************************

void CVIDCAP01Dlg::OnAdjust() 
{
	
	int result;
	
	
	HWND hwnd =PropSheet->GetSafeHwnd();
	if (!hwnd){
		page1=new CPropAdjust();
		page1->PassPointer(this);
		
		page2=new CPropAdvanced();
	    page2->PassPointer(this);
	
		page4=new CPropPageCrop();
		page4->PassPointer(this);
       
        
		if (m_CameraType>=4){
		  page5=new CAutoPosition();
		  page5->PassPointer(this);
		}
        
		PropSheet->AddPage(page1);
		PropSheet->AddPage(page2);
			
		PropSheet->AddPage(page4); 
		
		//***************** PTZ camera is being used so create "AutoPosition" property page*************
		if (m_CameraType>=4){  
		  PropSheet->AddPage(page5);
		}
		
		PropSheet->Create();
		
		PositionDialog();
	}
   PropSheet->BringWindowToTop();

  
}
	


void CVIDCAP01Dlg::OnPreviewno() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
    ::SetFocus(::GetDlgItem(m_hWnd,IDC_TILTUP));
}

void CVIDCAP01Dlg::OnPreviewyes() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
    ::SetFocus(::GetDlgItem(m_hWnd,IDC_TILTUP));	
}


void CVIDCAP01Dlg::PositionDialog()
{
   int POS,DialogWidth;
   RECT DialogRect;

   PropSheet->GetWindowRect( &DialogRect ); 
   GetWindowRect( &m_MainRect); 
   DialogWidth=DialogRect.right-DialogRect.left;

   POS=m_MainRect.left - DialogWidth; 
   if (POS <0 ){
	  SetWindowPos(NULL, DialogWidth +2, m_MainRect.top, 0, 0, SWP_NOSIZE || SWP_SHOWWINDOW );
       PropSheet-> SetWindowPos(&wndTopMost,2, m_MainRect.top, 0, 0, SWP_NOSIZE || SWP_SHOWWINDOW );  
   }
   else{
	   PropSheet->SetWindowPos(&wndTopMost, m_MainRect.left - DialogWidth,m_MainRect.top,0, 0, SWP_NOSIZE || SWP_SHOWWINDOW ); 
   }
}

//******************************************************************************************
//************** Accomodates Main Dialog to contain Live Video And Controls when cropping image
//*******************************************************************************************
void CVIDCAP01Dlg::ResizeMainWindow()
{
int NewWidth;
int NewHeight;
int VerticalSpacing;
int  tmpHorzSpacing,HorzSpacing;

CWnd *wnd;
CString str;

//NewWidth=m_CropWidth + 130;
//NewHeight=m_CropHeight + 60;

NewWidth=m_ScaleX + 130;
NewHeight=m_ScaleY + 60;
if (NewHeight<483) NewHeight=493;
SetWindowPos(&wndTopMost,0,0,NewWidth,NewHeight + 0,SWP_NOMOVE | SWP_SHOWWINDOW );

VerticalSpacing=5;

wnd=GetDlgItem(IDC_BUTTONHOME);
wnd->SetWindowPos(NULL,m_ScaleX + 11  ,125 + VerticalSpacing ,85,22,  SWP_SHOWWINDOW);

wnd=GetDlgItem(IDC_STATICZOOM);
wnd->MoveWindow(m_ScaleX + 16,148 + VerticalSpacing,80,54,TRUE);
wnd=GetDlgItem(IDC_ZOOMIN);
wnd->SetWindowPos(&wndTop,m_ScaleX+22,166 + VerticalSpacing,25,25, SWP_SHOWWINDOW);

wnd=GetDlgItem(IDC_ZOOMOUT);
wnd->SetWindowPos(&wndTop,m_ScaleX+ 61,166 + VerticalSpacing,25,25, SWP_SHOWWINDOW);

wnd=GetDlgItem(IDC_STATICPANTILT);
wnd->SetWindowPos(&wndTop,m_ScaleX+ 15,6,80,120,SWP_SHOWWINDOW);

wnd=GetDlgItem(IDC_PANLEFT);
wnd->SetWindowPos(&wndTop,m_ScaleX+22,56,0,0,SWP_NOSIZE || SWP_SHOWWINDOW);

wnd=GetDlgItem(IDC_PANRIGHT);
wnd->SetWindowPos(&wndTop,m_ScaleX+ 55,56,0,0,SWP_NOSIZE || SWP_SHOWWINDOW);

wnd=GetDlgItem(IDC_TILTUP);
wnd->SetWindowPos(&wndTop,m_ScaleX+40,24,0,0,SWP_NOSIZE || SWP_SHOWWINDOW);

wnd=GetDlgItem(IDC_TILTDOWN);
wnd->SetWindowPos(&wndTop,m_ScaleX+ 40,89,0,0,SWP_NOSIZE || SWP_SHOWWINDOW);

wnd=GetDlgItem(IDC_STATICBRIGHTNESS);
wnd->SetWindowPos(&wndTop,m_ScaleX+ 5,211 + VerticalSpacing,115,100, SWP_SHOWWINDOW);

wnd=GetDlgItem(IDC_IRISUP);
wnd->SetWindowPos(&wndTop,m_ScaleX+ 20,(231 + VerticalSpacing),0,0,SWP_NOSIZE);// || SWP_SHOWWINDOW);

wnd=GetDlgItem(IDC_IRISDOWN);
wnd->SetWindowPos(&wndTop,m_ScaleX+58,231 + VerticalSpacing,0,0,SWP_NOSIZE); //|| SWP_SHOWWINDOW);

wnd=GetDlgItem(IDC_STATICFLASHIRIS);
wnd->SetWindowPos(&wndTop,m_ScaleX+ 12,260 + VerticalSpacing,0,0,SWP_NOSIZE || SWP_SHOWWINDOW);

wnd=GetDlgItem(IDC_EDITFLASHIRIS);
wnd->SetWindowPos(&wndTop,m_ScaleX+ 25,276 + VerticalSpacing,65,20, SWP_SHOWWINDOW);

wnd=GetDlgItem(IDC_CAPTURE);
wnd->SetWindowPos(&wndTop,0,m_ScaleY + 1 ,m_ScaleX ,25, SWP_SHOWWINDOW);

if (m_ScaleX<410){
    HorzSpacing=2;
}
else{
	HorzSpacing=(m_ScaleX-400) / 3;
}
tmpHorzSpacing=HorzSpacing;

wnd=GetDlgItem(IDC_STATICUSEFLASH);
wnd->MoveWindow(m_ScaleX + 14,316 + VerticalSpacing ,93,55,SWP_SHOWWINDOW);

wnd=GetDlgItem(IDC_USEFLASHNO);
wnd->MoveWindow(m_ScaleX + 20 , 331+ VerticalSpacing,75, 16,TRUE );

wnd=GetDlgItem(IDC_USEFLASHYES);
wnd->MoveWindow(m_ScaleX + 20,353 + VerticalSpacing ,75,16,TRUE);

tmpHorzSpacing=HorzSpacing *2 + 147;

wnd=GetDlgItem(IDC_ADJUST);
wnd->SetWindowPos(NULL,m_ScaleX + 11  ,454 + VerticalSpacing ,95,22,  SWP_SHOWWINDOW);

tmpHorzSpacing=HorzSpacing * 3 +147 +105;


wnd=GetDlgItem(IDC_STATICPREVIEWCAPTURE);
wnd->MoveWindow(m_ScaleX +14 ,383 + VerticalSpacing ,96,55,TRUE);

wnd=GetDlgItem(IDC_PREVIEWNO);
wnd->MoveWindow(m_ScaleX + 26 ,420 + VerticalSpacing,38,16, TRUE);

wnd=GetDlgItem(IDC_PREVIEWYES);
wnd->MoveWindow(m_ScaleX + 26 ,397 + VerticalSpacing,44,16, TRUE);

Invalidate(TRUE);
}



//*********************************************************************************************
//*************** Translates keyboards events for Pan/Titl/Zoom control **************************************
//***********************************************************************************************

BOOL CVIDCAP01Dlg::PreTranslateMessage(MSG* pMsg) 
{
	// TODO: Add your specialized code here and/or call the base class
    if (pMsg->message==WM_KEYDOWN){	
	 switch(pMsg->wParam){
     case VK_SHIFT:
		 if (Shift==FALSE){
			 Shift=TRUE;
			 if (Up==TRUE){
                 if (m_TiltReverse==FALSE)
				   VALCam_Control(VC_TiltUpSlow,0,0,0,0);
				 else
				   VALCam_Control(VC_TiltDownSlow,0,0,0,0);
				 break;
			 }
			 if (Down==TRUE){
                 if (m_TiltReverse==FALSE)  
				   VALCam_Control(VC_TiltDownSlow,0,0,0,0);
				 else
                    VALCam_Control(VC_TiltUpSlow,0,0,0,0);
				 break;
			 }
			 if (Left==TRUE){
                 if (m_TiltReverse==FALSE)    
				   VALCam_Control(VC_PanRightSlow,0,0,0,0);
				 else
                   VALCam_Control(VC_PanLeftSlow,0,0,0,0);
				 break;
			 }
			 if (Right==TRUE){
                 if (m_TiltReverse==FALSE)    
				   VALCam_Control(VC_PanLeftSlow,0,0,0,0);
				 else
                   VALCam_Control(VC_PanRightSlow,0,0,0,0);
				 break;
			 }
			 if (Add==TRUE){
                 VALCam_Control(VC_ZoomInSlow,0,0,0,0);
				// m_AutoZoomGood=FALSE;
				 break;
			 }
			 if (Subtract==TRUE){
                VALCam_Control(VC_ZoomOutSlow,0,0,0,0);
				 break;
			 }
		 }
		 break;
    
	 case VK_CONTROL:
		 if (Control==FALSE){
			 Control=TRUE;
			 if (Up==TRUE){
                 if (m_TiltReverse==TRUE)
				   VALCam_Control(VC_TiltDownFast,0,0,0,0);
				 else
                   VALCam_Control(VC_TiltUpFast,0,0,0,0);
				 break;
			 }
			 if (Down==TRUE){
                 if (m_TiltReverse==TRUE)  
				   VALCam_Control(VC_TiltUpFast,0,0,0,0);
				 else
                    VALCam_Control(VC_TiltDownFast,0,0,0,0);
				 break;
			 }
			 if (Left==TRUE){
                 if (m_PanReverse==TRUE)
				   VALCam_Control(VC_PanLeftFast,0,0,0,0);
				 else
                   VALCam_Control(VC_PanRightFast,0,0,0,0);
				 break;
			 }
			 if (Right==TRUE){
                 if(m_PanReverse==TRUE) 
				   VALCam_Control(VC_PanRightFast,0,0,0,0);
                 else
                   VALCam_Control(VC_PanLeftFast,0,0,0,0);
				 break;
			 }
			 if (Add==TRUE){
                 VALCam_Control(VC_ZoomInFast,0,0,0,0);	 
				 m_AutoZoomGood=FALSE;
				 break;
			 }
			 if (Subtract==TRUE){
				   VALCam_Control(VC_ZoomOutFast,0,0,0,0);	 
				 m_AutoZoomGood=FALSE;
				 break;
			 }
		 }
		 break;
   		 
	 
	 case VK_UP:
		
		 if (( m_KeyCount < 4) && (m_CameraType>1))
		 {
		     m_KeyCount++;
		//	 m_pVc3Ctrl->Set(VC_CTRL_VISCA ,161, 0 );
		     VALCam_Control(VC_SetPanTiltPosition,0,-5,0,0);
			 Up=FALSE;
			 break;
		 }
		 if (Up==FALSE){         
            
			if (Shift==TRUE){
			   if (m_TiltReverse==TRUE)	
				   VALCam_Control(VC_TiltDownSlow,0,0,0,0);
			   else
				   VALCam_Control(VC_TiltUpSlow,0,0,0,0);
			   Up=TRUE;
				break;
			}

			if (Control==TRUE){
				 if (m_TiltReverse==TRUE)	
				   VALCam_Control(VC_TiltDownFast,0,0,0,0);
			   else
				   VALCam_Control(VC_TiltUpFast,0,0,0,0);
				Up=TRUE;
				break;
			}

			switch(m_PTZSpeed){
				case 0: 
					
			   if (m_TiltReverse==TRUE)	
				   VALCam_Control(VC_TiltDownSlow,0,0,0,0);
			   else
				   VALCam_Control(VC_TiltUpSlow,0,0,0,0);
					break;
                
				case 1: 
					if (m_CameraType>=4){
						if (m_TiltReverse==TRUE)	
				           VALCam_Control(VC_TiltDown,0,0,0,0);
			            else
				           VALCam_Control(VC_TiltUp,0,0,0,0);
					}
					else if (m_CameraType<3){
						     if (m_TiltReverse==TRUE)	
				               VALCam_Control(VC_TiltDownSlow,0,0,0,0);
			                 else
				               VALCam_Control(VC_TiltUpSlow,0,0,0,0);
					}
					break;
                
				case 2: 
				    if (m_CameraType>=4){
					  if (m_TiltReverse==TRUE)	
				        VALCam_Control(VC_TiltDownFast,0,0,0,0);
			          else
				         VALCam_Control(VC_TiltUpFast,0,0,0,0);
					}
					else if (m_CameraType<3){
						   if (m_TiltReverse==TRUE)	
				             VALCam_Control(VC_TiltDown,0,0,0,0);
			               else
				             VALCam_Control(VC_TiltUp,0,0,0,0);      
						//VALCam_Control(VC_TiltDown,0,0,0,0);
					}
					break; 

                default: 
					if (m_CameraType>=4){
						if (m_TiltReverse==TRUE)	
				          VALCam_Control(VC_TiltDown,0,0,0,0);
			            else
				          VALCam_Control(VC_TiltUp,0,0,0,0);
						
						//VALCam_Control(VC_TiltDown,0,0,0,0);
					}
					else if (m_CameraType<3){
						     if (m_TiltReverse==TRUE)	
				               VALCam_Control(VC_TiltDownSlow,0,0,0,0);
			                 else
				               VALCam_Control(VC_TiltUpSlow,0,0,0,0);     
						
						//VALCam_Control(VC_TiltDownSlow,0,0,0,0);
					}
					break;
			}
         Up=TRUE;	     
		}
		break;//return(0);
        
     case VK_DOWN:
		 	 if (( m_KeyCount < 4)  && (m_CameraType>1))
		 {
		     m_KeyCount++;
			 //m_pVc3Ctrl->Set(VC_CTRL_VISCA ,162, 0 );
		     VALCam_Control(VC_SetPanTiltPosition,0,5,0,0);
			 
			 Down=FALSE;
			 break;
		 }
		 
		 
		 if (Down==FALSE){ 			 
             Sleep(300);
			 if (Shift==TRUE){
			    if (m_TiltReverse==TRUE)
					VALCam_Control(VC_TiltUpSlow,0,0,0,0);
				else
					VALCam_Control(VC_TiltDownSlow,0,0,0,0);
				Down=TRUE;
				break;
			}
		   
		    if (Control==TRUE){
				 if (m_TiltReverse==TRUE)
					VALCam_Control(VC_TiltUpFast,0,0,0,0);
				else
					VALCam_Control(VC_TiltDownFast,0,0,0,0);
				//VALCam_Control(VC_TiltUpFast,0,0,0,0);
				Down=TRUE;
				break;
			}
		 	 		 
			 switch(m_PTZSpeed){
				case 0: 
					 if (m_TiltReverse==TRUE)
					VALCam_Control(VC_TiltUpSlow,0,0,0,0);
				else
					VALCam_Control(VC_TiltDownSlow,0,0,0,0);
					//VALCam_Control(VC_TiltUpSlow,0,0,0,0);
					break;
                
				case 1: 
					if (m_CameraType>=4){
					  if (m_TiltReverse==TRUE)
						VALCam_Control(VC_TiltUp,0,0,0,0);
					  else
						VALCam_Control(VC_TiltDown,0,0,0,0);
						//VALCam_Control(VC_TiltUp,0,0,0,0);
					}
					else if (m_CameraType<3){
						   if (m_TiltReverse==TRUE)
							 VALCam_Control(VC_TiltUpSlow,0,0,0,0);
				           else
					         VALCam_Control(VC_TiltDownSlow,0,0,0,0);     
						//VALCam_Control(VC_TiltUpSlow,0,0,0,0);
					}
					break;
                
				case 2: 
				    if (m_CameraType>=4){
					  if (m_TiltReverse==TRUE)
						VALCam_Control(VC_TiltUpFast,0,0,0,0);
					  else
						VALCam_Control(VC_TiltDownFast,0,0,0,0);
						//VALCam_Control(VC_TiltUpFast,0,0,0,0);
					}
					else if (m_CameraType<3){
						  if (m_TiltReverse==TRUE)
					        VALCam_Control(VC_TiltUp,0,0,0,0);
				          else
					        VALCam_Control(VC_TiltDown,0,0,0,0);     
						//VALCam_Control(VC_TiltUp,0,0,0,0);
					}
					break; 

                default: 
					if (m_CameraType>=4){
					  if (m_TiltReverse==TRUE)
					    VALCam_Control(VC_TiltUp,0,0,0,0);
			    	  else
						VALCam_Control(VC_TiltDown,0,0,0,0);
						//VALCam_Control(VC_TiltUp,0,0,0,0);
					}
					else if (m_CameraType<3){
					  if (m_TiltReverse==TRUE)
					    VALCam_Control(VC_TiltUpSlow,0,0,0,0);
				      else
					    VALCam_Control(VC_TiltDownSlow,0,0,0,0);
						//m_pVc3Ctrl->Set(  VC_CTRL_VISCA,CAM_CTL_TILTUPSLOW, 0 );
					}
					break;
			}
          Down=TRUE	     ;
		 }
		 return(1);
                  

     case VK_LEFT:
		 	 if (( m_KeyCount <4)  && (m_CameraType>1))
		 {
		     m_KeyCount++;
			// m_pVc3Ctrl->Set(VC_CTRL_VISCA ,164, 0 );
		     VALCam_Control(VC_SetPanTiltPosition,5,0,0,0);
			 Left=FALSE;
			 break;
		 }
		 
		 if (Left==FALSE){                   
			 if (Shift==TRUE){
				if (m_PanReverse==TRUE)
				  VALCam_Control(VC_PanLeftSlow,0,0,0,0);
				else
                  VALCam_Control(VC_PanRightSlow,0,0,0,0);
				Left=TRUE;
				break;
			} 
			if (Control==TRUE){
				if (m_PanReverse==TRUE)
				  VALCam_Control(VC_PanLeftFast,0,0,0,0);
				else
                  VALCam_Control(VC_PanRightFast,0,0,0,0);
				//VALCam_Control(VC_PanLeftFast,0,0,0,0);
				Left=TRUE;
				break;
			} 
			 switch(m_PTZSpeed){
				case 0: 
					if (m_PanReverse==TRUE)
				      VALCam_Control(VC_PanLeftSlow,0,0,0,0);
				    else
                      VALCam_Control(VC_PanRightSlow,0,0,0,0);
					//VALCam_Control(VC_PanLeftSlow,0,0,0,0);
					break;
                
				case 1: 
					if (m_CameraType>=4){
						if (m_PanReverse==TRUE)
				           VALCam_Control(VC_PanLeft,0,0,0,0);
				        else
                           VALCam_Control(VC_PanRight,0,0,0,0);
						//VALCam_Control(VC_PanLeft,0,0,0,0);
					}
					else if (m_CameraType<3){
						   if (m_PanReverse==TRUE)
				             VALCam_Control(VC_PanLeftSlow,0,0,0,0);
				           else
                             VALCam_Control(VC_PanRightSlow,0,0,0,0);     
						//VALCam_Control(VC_PanLeftSlow,0,0,0,0);
					}
					break;
                
				case 2: 
				    if (m_CameraType>=4){
						if (m_PanReverse==TRUE)
				           VALCam_Control(VC_PanLeftFast,0,0,0,0);
				        else
                           VALCam_Control(VC_PanRightFast,0,0,0,0);
						//VALCam_Control(VC_PanLeftFast,0,0,0,0);
					}
					else if (m_CameraType<3){
						    if (m_PanReverse==TRUE)
				               VALCam_Control(VC_PanLeft,0,0,0,0);
				            else
                               VALCam_Control(VC_PanRight,0,0,0,0);     
						//VALCam_Control(VC_PanLeft,0,0,0,0);
					}
					break; 

                default: 
					if (m_CameraType>=4){
						if (m_PanReverse==TRUE)
				          VALCam_Control(VC_PanLeft,0,0,0,0);
				        else
                          VALCam_Control(VC_PanRight,0,0,0,0);
						//VALCam_Control(VC_PanLeft,0,0,0,0);
					}
					else if (m_CameraType<3){
						   if (m_PanReverse==TRUE)
				              VALCam_Control(VC_PanLeftSlow,0,0,0,0);
				           else
                               VALCam_Control(VC_PanRightSlow,0,0,0,0);     
						//VALCam_Control(VC_PanLeftSlow,0,0,0,0);
					}
					break;
			}

         Left=TRUE;
		 }
		 return(1);

     case VK_RIGHT:
        	 if (( m_KeyCount < 4)  && (m_CameraType>1))
		 {
		     m_KeyCount++;
			 VALCam_Control(VC_SetPanTiltPosition,-5,0,0,0);
		     Right=FALSE;
			 break;
		 }
		 
		 if (Right==FALSE){         
          if (Shift==TRUE){
			 if (m_PanReverse==TRUE)
				  VALCam_Control(VC_PanRightSlow,0,0,0,0);
				else
                  VALCam_Control(VC_PanLeftSlow,0,0,0,0);	
				Right=TRUE;
				break;
			}

		  if (Control==TRUE){
			   if (m_PanReverse==TRUE)
				  VALCam_Control(VC_PanRightFast,0,0,0,0);
			   else
                  VALCam_Control(VC_PanLeftFast,0,0,0,0);		
				Right=TRUE;
				break;
			}
						
			switch(m_PTZSpeed){
				case 0: 
					 if (m_PanReverse==TRUE)
				       VALCam_Control(VC_PanRightSlow,0,0,0,0);
				     else
                       VALCam_Control(VC_PanLeftSlow,0,0,0,0);	
					//VALCam_Control(VC_PanRightSLOW,0,0,0,0);
					break;
                
				case 1: 
					if (m_CameraType>=4){
						 if (m_PanReverse==TRUE)
				  VALCam_Control(VC_PanRight,0,0,0,0);
				else
                  VALCam_Control(VC_PanLeft,0,0,0,0);	
						//VALCam_Control(VC_PanRight,0,0,0,0);
					}
					else if (m_CameraType<3){
						 if (m_PanReverse==TRUE)
				  VALCam_Control(VC_PanRightSlow,0,0,0,0);
				else
                  VALCam_Control(VC_PanLeftSlow,0,0,0,0);	     
						//VALCam_Control(VC_PanRightSLOW,0,0,0,0);
					}
					break;
                
				case 2: 
				    if (m_CameraType>=4){
						 if (m_PanReverse==TRUE)
				  VALCam_Control(VC_PanRightFast,0,0,0,0);
				else
                  VALCam_Control(VC_PanLeftFast,0,0,0,0);	
						//VALCam_Control(VC_PanRightFast,0,0,0,0);
					}
					else if (m_CameraType<3){
						   if (m_PanReverse==TRUE)
				  VALCam_Control(VC_PanRight,0,0,0,0);
				else
                  VALCam_Control(VC_PanLeft,0,0,0,0);	     
						//VALCam_Control(VC_PanRight,0,0,0,0);
					}
					break; 

                default: 
					if (m_CameraType>=4){
				     	 if (m_PanReverse==TRUE)
				  VALCam_Control(VC_PanRight,0,0,0,0);
				else
                  VALCam_Control(VC_PanLeft,0,0,0,0);		
						//VALCam_Control(VC_PanRight,0,0,0,0);
					}
					else if (m_CameraType<3){
						 if (m_PanReverse==TRUE)
				  VALCam_Control(VC_PanRightSlow,0,0,0,0);
				else
                  VALCam_Control(VC_PanLeftSlow,0,0,0,0);	     
						//VALCam_Control(VC_PanRightSLOW,0,0,0,0);
					}
					break;
			}
         Right=TRUE;
		 }
		 return(1);


     case VK_ADD:
        
		 
		 if (Add==FALSE){         
          if (Shift==TRUE){
				VALCam_Control(VC_ZoomInSlow,0,0,0,0);
				Add=TRUE;
				m_AutoZoomGood=FALSE;
				break;
			}
		  if (Control==TRUE){
				VALCam_Control(VC_ZoomInFast,0,0,0,0);
				Add=TRUE;
				m_AutoZoomGood=FALSE;
				break;
			} 

			switch(m_PTZSpeed){
				case 0: 
					VALCam_Control(VC_ZoomInSlow,0,0,0,0);
					m_AutoZoomGood=FALSE;
					break;
                
				case 1: 
					VALCam_Control(VC_ZoomIn,0,0,0,0);
					m_AutoZoomGood=FALSE;
					break;
                
				case 2: 
					VALCam_Control(VC_ZoomInFast,0,0,0,0);
					m_AutoZoomGood=FALSE;
					break; 

                default: 
					VALCam_Control(VC_ZoomIn,0,0,0,0);
					m_AutoZoomGood=FALSE;
					break;
				}
         Add=TRUE;
		 }
		 return(1);


     case VK_SUBTRACT:
        
		  if (m_LockZoom==TRUE){
				
			  MessageBox("Zoom is locked, See administrator","Zoom Locked",0);
			  break; 				
			}
		 
		 if (Subtract==FALSE){         
          if (Shift==TRUE){
				VALCam_Control(VC_ZoomOutSlow,0,0,0,0);
				Subtract=TRUE;
				m_AutoZoomGood=FALSE;
				break;
			}
		   
		  if (Control==TRUE){
				VALCam_Control(VC_ZoomOutFast,0,0,0,0);
				Subtract=TRUE;
				m_AutoZoomGood=FALSE;
				break;
			}	
			
		  switch(m_PTZSpeed){
				case 0: 
					VALCam_Control(VC_ZoomOutSlow,0,0,0,0);
					m_AutoZoomGood=FALSE;
					break;
                
				case 1: 
					VALCam_Control(VC_ZoomOut,0,0,0,0);
					m_AutoZoomGood=FALSE;
					break;
                
				case 2: 
					VALCam_Control(VC_ZoomOutFast,0,0,0,0);
					m_AutoZoomGood=FALSE;
					break; 

                default: 
					VALCam_Control(VC_ZoomOut,0,0,0,0);
					m_AutoZoomGood=FALSE;
					break;
				}
         Subtract=TRUE;
		 }
		 return(1);
	 }
 }
 else{
   
   if (pMsg->message==WM_KEYUP){	
	  	       
	  switch(pMsg->wParam){      
       
	  case VK_SHIFT:
		  Shift=FALSE;
		  if (Up==TRUE){
			  VALCam_Control(VC_TiltUp,0,0,0,0);
			  break;
		  }
		  if (Down==TRUE){
			  VALCam_Control(VC_TiltDown,0,0,0,0);
			  break;
		  }
		  if (Left==TRUE){
			  VALCam_Control(VC_PanRight,0,0,0,0);
			   break;
		  }
		  if (Right==TRUE){
			  VALCam_Control(VC_PanLeft,0,0,0,0);
			  break;		  }

		  if (Add==TRUE){
			  VALCam_Control(VC_ZoomIn,0,0,0,0);
			  m_AutoZoomGood=FALSE; 
			  break;
		  }
		  if (Subtract==TRUE){
			  VALCam_Control(VC_ZoomOut,0,0,0,0);
			  m_AutoZoomGood=FALSE;
			  break;
		  }
		    break;

       case VK_CONTROL:
		  Control=FALSE;
		  if (Up==TRUE){
			  VALCam_Control(VC_TiltUp,0,0,0,0);
			  break;
		  }
		  if (Down==TRUE){
			  VALCam_Control(VC_TiltDown,0,0,0,0);
			  break;
		  }
		  if (Right==TRUE){
			  VALCam_Control(VC_PanLeft,0,0,0,0);
			  break;
		  }
		  if (Left==TRUE){
			  VALCam_Control(VC_PanRight,0,0,0,0);
			  break;
		  }

		  if (Add==TRUE){
			  VALCam_Control(VC_ZoomIn,0,0,0,0);
			  m_AutoZoomGood=FALSE;
			  break;
		  }
		  if (Subtract==TRUE){
			  VALCam_Control(VC_ZoomOut,0,0,0,0);
			  m_AutoZoomGood=FALSE;
			  break;
		  }
		      break;

	  case VK_UP:
		   
		   ::SetFocus(::GetDlgItem(m_hWnd,IDC_TILTUP));
		  
		 Up=FALSE;         
         Sleep(85);
		VALCam_Control(VC_PanTiltStop,0,0,0,0);//CamCtl32(CM_PanLeft,0);
        
		 m_KeyCount=0;
		 return(1);
		 
       case  VK_DOWN:
		 Down=FALSE;         
         Sleep(85);
		VALCam_Control(VC_PanTiltStop,0,0,0,0);//CamCtl32(CM_PanLeft,0);
         Down=FALSE;
		 m_KeyCount=0;
		 return(1);
	
        
	   case VK_LEFT:	          
         Sleep(85);
		VALCam_Control(VC_PanTiltStop,0,0,0,0);//CamCtl32(CM_PanLeft,0);
         Left=FALSE;
		 m_KeyCount=0;
		 return(1);        

        case VK_RIGHT:
		 Left=FALSE;         
         Sleep(85);
		VALCam_Control(VC_PanTiltStop,0,0,0,0);// CamCtl32(CM_PanLeft,0);
         Right=FALSE;
		 m_KeyCount=0;
		 return(1);        

        case VK_ADD:         
         Add=FALSE;
         Sleep(85);
		VALCam_Control(VC_ZoomStop,0,0,0,0);         
         m_KeyCount=0;
		 return(1);

        case VK_SUBTRACT:
         Subtract=FALSE;         
         Sleep(85);
		VALCam_Control(VC_ZoomStop,0,0,0,0);
         m_KeyCount=0;
		 return(1);
	  }
  }
 } 			
	
		return CDialog::PreTranslateMessage(pMsg);
}

//********************************************************************************************
//**** Set Flash Iris Distance that corresponeds to Flash Iris Settings to display string in Main Dialog ****
//********************************************************************************************

void CVIDCAP01Dlg::FlashIrisLevelDistance()
{
	switch (m_CameraType){

	case 1:  //For older Pan/Tilt/Zoom camera
		switch (m_FlashIrisLevel){
		case 1:
		case 2:
		case 3:
		case 4:
		case 5:
		case 6:
			m_FlashIrisLevelstr="10 in ";			
			break;
		case 7:
			m_FlashIrisLevelstr="1.4 Feet";
			break;
        case 8:
			m_FlashIrisLevelstr=" 1.5 Feet";
			break;
        case 9:
			m_FlashIrisLevelstr="1.6 Feet";//" 2 Feet";
			break;
        case 10:
			m_FlashIrisLevelstr="1.8 Feet";//" 2.2 Feet";
			break;
        case 11:
			m_FlashIrisLevelstr="1.85 Feet";//" 2.4 Feet ";
			break;
        case 12:
			m_FlashIrisLevelstr="1.9 Feet ";
			break;
		case 13:
			m_FlashIrisLevelstr="2 Feet";//" 2.7 Feet ";
			break;	
		case 14:
			m_FlashIrisLevelstr=" 2.4 Feet";//" 2.9 Feet ";
			break;
		case 15:
			m_FlashIrisLevelstr=" 2.7 Feet ";
			break;
		case 16:
			m_FlashIrisLevelstr=" 2.9 Feet ";
			break;
		case 17:
			m_FlashIrisLevelstr=" 3.7 Feet ";
			break;
		case 18:
			m_FlashIrisLevelstr=" 3.9 Feet ";
			break;
		case 19:
			m_FlashIrisLevelstr=" 4 Feet ";
			break;
		case 20:
			m_FlashIrisLevelstr=" 4.2 Feet ";
			break;			
		case 21:
			m_FlashIrisLevelstr=" 4.8 Feet ";
			break;
        case 22:
			m_FlashIrisLevelstr=" 5.2 Feet ";
			break;   
        case 23:
			m_FlashIrisLevelstr=" 6.2 Feet ";;
			break;
		case 24:
			m_FlashIrisLevelstr=" 7 Feet ";
			break;
		case 25:
			m_FlashIrisLevelstr=" 8 Feet ";
			break;
        case 26:
			m_FlashIrisLevelstr=" 8.5 Feet ";
			break; 
		case 27:
			m_FlashIrisLevelstr=" 9 Feet ";
			break;
		case 28:
			m_FlashIrisLevelstr=" 9.8 Feet ";
			break;
		case 29:
			m_FlashIrisLevelstr=" 10.5 Feet";//" 10 Feet ";
			break;
		case 30:
			m_FlashIrisLevelstr=" 11 Feet";//" 10.5 Feet";
			break;
		case 31:
			m_FlashIrisLevelstr=" 11.5 Feet";//" 10.5 Feet ";
			break;
        case 32:
			m_FlashIrisLevelstr=" 12 Feet";//" 10 Feet ";
			break;
		}
		break;

	
	
	
	case 3:  //******************************* For Zoom only camera************************************
		switch (m_FlashIrisLevel){
		case 1:
		case 2:
		case 3:
		case 4:
		case 5:
		case 6:
			m_FlashIrisLevelstr="Under 1.2 Feet ";
			//m_FlashDistanceCompensation=1;
			break;
		case 7:
			m_FlashIrisLevelstr=" 1.2 Feet";
		//	m_FlashDistanceCompensation=1;
			break;
        case 8:
			m_FlashIrisLevelstr=" 1.5 Feet";
		//	m_FlashDistanceCompensation=2;
			break;
        case 9:
			m_FlashIrisLevelstr=" 2.0 Feet";//" 2 Feet";
		//	m_FlashDistanceCompensation=2;
			break;
        case 10:
			m_FlashIrisLevelstr=" 2.2 Feet";//" 2.2 Feet";
		//	m_FlashDistanceCompensation=2;
			break;
        case 11:
			m_FlashIrisLevelstr=" 2.3 Feet";//" 2.4 Feet ";
		//	m_FlashDistanceCompensation=1;
			break;
        case 12:
			m_FlashIrisLevelstr=" 2.5 Feet ";
		//	m_FlashDistanceCompensation=3;
			break;
		case 13:
			m_FlashIrisLevelstr=" 2.8 Feet";//" 2.7 Feet ";
		//	m_FlashDistanceCompensation=3;
			break;	
		case 14:
			m_FlashIrisLevelstr=" 3.0 Feet";//" 2.9 Feet ";
		//	m_FlashDistanceCompensation=3;
			break;
		case 15:
			m_FlashIrisLevelstr=" 3.2 Feet ";
		//	m_FlashDistanceCompensation=3;
			break;
		case 16:
			m_FlashIrisLevelstr=" 3.6 Feet ";
		//	m_FlashDistanceCompensation=4;
			break;
		case 17:
			m_FlashIrisLevelstr=" 4 Feet ";
		//	m_FlashDistanceCompensation=4;
			break;
		case 18:
			m_FlashIrisLevelstr=" 4.8 Feet ";
		//	m_FlashDistanceCompensation=4;
			break;
		case 19:
			m_FlashIrisLevelstr=" 5 Feet ";
		//	m_FlashDistanceCompensation=5;
			break;
		case 20:
			m_FlashIrisLevelstr=" 5.6 Feet ";
		//	m_FlashDistanceCompensation=5;
			break;			
		case 21:
			m_FlashIrisLevelstr=" 6.8 Feet ";
		//	m_FlashDistanceCompensation=5;
			break;
        case 22:
			m_FlashIrisLevelstr=" 7.8 Feet ";
		//	m_FlashDistanceCompensation=6;
			break;   
        case 23:
			m_FlashIrisLevelstr=" 8.9 Feet ";;
		//	m_FlashDistanceCompensation=6;
			break;
		case 24:
			m_FlashIrisLevelstr=" 10.5 Feet ";
		//	m_FlashDistanceCompensation=6;
			break;
		case 25:
			m_FlashIrisLevelstr=" 11 Feet ";
		//	m_FlashDistanceCompensation=6;
			break;
        case 26:
			m_FlashIrisLevelstr=" 12.6 Feet ";
		//	m_FlashDistanceCompensation=6;
			break; 
		case 27:
			m_FlashIrisLevelstr=" 14.8 Feet ";
		//	m_FlashDistanceCompensation=6;
			break;
		case 28:
			m_FlashIrisLevelstr=" 15.5 Feet ";
		//	m_FlashDistanceCompensation=7;
			break;
		case 29:
			m_FlashIrisLevelstr=" 16 Feet";//" 10 Feet ";
		//	m_FlashDistanceCompensation=7;
			break;
		case 30:
			m_FlashIrisLevelstr=" 16.3 Feet";//" 10.5 Feet";
		//	m_FlashDistanceCompensation=7;
			break;
		case 31:
			m_FlashIrisLevelstr=" 16.8 Feet";//" 10.5 Feet ";
		//	m_FlashDistanceCompensation=8;
			break;
        case 32:
			m_FlashIrisLevelstr=" 17 Feet";//" 10 Feet ";
		//	m_FlashDistanceCompensation=8;
			break;
		}
		break;

	case 4:  //*************** For older Pan/Tilt/Zoom Camera***************************************
	 switch (m_FlashIrisLevel){
		case 1:
		case 2:
		case 3:
		case 4:
		case 5:
		case 6:
			m_FlashIrisLevelstr="Under 1.2 Feet ";
			break;
		case 7:
			m_FlashIrisLevelstr=" 1.5 Feet";
			break;
        case 8:
			m_FlashIrisLevelstr=" 1.7 Feet";
			break;
        case 9:
			m_FlashIrisLevelstr=" 1.8 Feet";
			break;
        case 10:
			m_FlashIrisLevelstr=" 2.0 Feet";
			break;
        case 11:
			m_FlashIrisLevelstr=" 2.2 Feet ";
			break;
        case 12:
			m_FlashIrisLevelstr=" 2.3 Feet ";
			break;
		case 13:
			m_FlashIrisLevelstr=" 2.4 Feet ";
			break;	
		case 14:
			m_FlashIrisLevelstr=" 2.5 Feet ";
			break;
		case 15:
			m_FlashIrisLevelstr=" 2.6 Feet ";
			break;
		case 16:
			m_FlashIrisLevelstr=" 2.7 Feet ";
			break;
		case 17:
			m_FlashIrisLevelstr=" 2.75 Feet ";
			break;
		case 18:
			m_FlashIrisLevelstr=" 2.8 Feet ";
			break;
		case 19:
			m_FlashIrisLevelstr=" 2.9 Feet ";
			break;
		case 20:
			m_FlashIrisLevelstr=" 3 Feet ";
			break;			
		case 21:
			m_FlashIrisLevelstr=" 3.3 Feet ";
			break;
        case 22:
			m_FlashIrisLevelstr=" 3.8 Feet ";
			break;   
        case 23:
			m_FlashIrisLevelstr=" 4 Feet ";;
			break;
		case 24:
			m_FlashIrisLevelstr=" 4.5 Feet ";
			break;
		case 25:
			m_FlashIrisLevelstr=" 5 Feet ";
			break;
        case 26:
			m_FlashIrisLevelstr=" 5.5 Feet ";
			break; 
		case 27:
			m_FlashIrisLevelstr=" 6 Feet ";
			break;
		case 28:
			m_FlashIrisLevelstr=" 6.5 Feet ";
			break;
		case 29:
			m_FlashIrisLevelstr=" 7 Feet ";
			break;
		case 30:
			m_FlashIrisLevelstr=" 8 Feet";
			break;
		case 31:
			m_FlashIrisLevelstr=" 9 Feet ";
			break;
		case 32:
			m_FlashIrisLevelstr=" 10 Feet ";
			break;
		}
		break;
	 case 5:  //********************************* For Current Pan/Tilt/Zoom Camera **********************
      switch (m_FlashIrisLevel){
        case 1: m_FlashIrisLevelstr="Under 3 Inches ";
		case 2: m_FlashIrisLevelstr=" 4 Inches ";
		case 3: m_FlashIrisLevelstr=" 5 Inches ";
		case 4: m_FlashIrisLevelstr=" 6 Inches ";
		case 5: m_FlashIrisLevelstr=" 6.5  Inches ";
		case 6:
			m_FlashIrisLevelstr=" 8 inches ";
		//	m_FlashDistanceCompensation=1;
			break;
		case 7:
			m_FlashIrisLevelstr= " 1 Foot";//" 1.5 Feet";
		//	m_FlashDistanceCompensation=1;
			break;
        case 8:
			m_FlashIrisLevelstr= " 1.2 Feet";//" 1.2 Feet";
		//	m_FlashDistanceCompensation=2;
			break;
        case 9:
			m_FlashIrisLevelstr=" 1.3 Feet";//" 1.3 Feet";
		//	m_FlashDistanceCompensation=2;
			break;
        case 10:
			m_FlashIrisLevelstr=" 1.5 Feet";//" 1.4 Feet";
		//	m_FlashDistanceCompensation=2;
			break;
        case 11:
			m_FlashIrisLevelstr=" 1.6 Feet";//" 1.6 Feet ";
		//	m_FlashDistanceCompensation=3;
			break;
        case 12:
			m_FlashIrisLevelstr=" 1.8 Feet";//" 1.8 Feet ";
		//	m_FlashDistanceCompensation=3;
			break;
		case 13:
			m_FlashIrisLevelstr=" 2 Feet";//" 2 Feet ";
		//	m_FlashDistanceCompensation=3;
			break;	
		case 14:
			m_FlashIrisLevelstr=" 2.5 Feet";//" 3 Feet ";
		//	m_FlashDistanceCompensation=4;
			break;
		case 15:
			m_FlashIrisLevelstr=" 3 Feet";//" 4 Feet ";
		//	m_FlashDistanceCompensation=4;
			break;
		case 16:
			m_FlashIrisLevelstr=" 3.5 Feet";//" 5 Feet ";
		//	m_FlashDistanceCompensation=4;
			break;
		case 17:
			m_FlashIrisLevelstr=" 4 Feet";//" 6 Feet ";
		//	m_FlashDistanceCompensation=4;
			break;
		case 18:
			m_FlashIrisLevelstr=" 5 Feet";//" 7 Feet ";
		//	m_FlashDistanceCompensation=5;
			break;
		case 19:
			m_FlashIrisLevelstr=" 5.5 Feet";//" 8 Feet ";
		//	m_FlashDistanceCompensation=5;
			break;
		case 20:
			m_FlashIrisLevelstr=" 6 Feet";//" 9 Feet ";
		//	m_FlashDistanceCompensation=5;
			break;			
		case 21:
			m_FlashIrisLevelstr=" 7 Feet";//" 10 Feet ";
		//	m_FlashDistanceCompensation=6;
			break;
        case 22:
			m_FlashIrisLevelstr=" 8 Feet";//" 11 Feet ";
		//	m_FlashDistanceCompensation=6;
			break;   
        case 23:
			m_FlashIrisLevelstr=" 9 Feet";//" 12 Feet ";;
		//	m_FlashDistanceCompensation=6;
			break;
		case 24:
			m_FlashIrisLevelstr=" 10 Feet";//" 13 Feet ";
		//	m_FlashDistanceCompensation=6;
			break;
		case 25:
			m_FlashIrisLevelstr=" 11 Feet";//" 14 Feet ";
		//	m_FlashDistanceCompensation=7;
			break;
        case 26:
			m_FlashIrisLevelstr=" 11.5 Feet";//" 15 Feet ";
		//	m_FlashDistanceCompensation=7;
			break; 
		case 27:
			m_FlashIrisLevelstr=" 12 Feet";//" 16 Feet ";
		//	m_FlashDistanceCompensation=7;
			break;
		case 28:
			m_FlashIrisLevelstr=" 12.5 Feet";//" 16+ Feet ";
		//	m_FlashDistanceCompensation=7;
			break;
		case 29:
			m_FlashIrisLevelstr=" 13 Feet";//" 16++ Feet ";
		//	m_FlashDistanceCompensation=8;
			break;
		case 30:
			m_FlashIrisLevelstr=" 14 - 15 Feet";//" 17+++ Feet";
		//	m_FlashDistanceCompensation=8;
			break;
		case 31:
			m_FlashIrisLevelstr=" 16 - 17 Feet";//" 19 Feet ";
		//	m_FlashDistanceCompensation=8;
			break;
		case 32:
			m_FlashIrisLevelstr=" 18 -20 Feet ";
		//	m_FlashDistanceCompensation=8;
			break;
			}
			   
		break;
		  }
 UpdateData(FALSE);		  
}



void CVIDCAP01Dlg::BogusCapture()
{

}

  


void CVIDCAP01Dlg::UpdateDialog()
{
  //UpdateData(FALSE);
}



void CVIDCAP01Dlg::Make_Interface_Visible(BOOL Visible)
{
CWnd* wnd;
Visible ? m_ColorAdjustVisible=FALSE :	m_ColorAdjustVisible=TRUE;
wnd=GetDlgItem(IDC_BUTTONHOME);
Visible ? wnd->ShowWindow(SW_SHOW) : wnd->ShowWindow(SW_HIDE);


wnd=GetDlgItem(IDC_STATICZOOM);
Visible ? wnd->ShowWindow(SW_SHOW) : wnd->ShowWindow(SW_HIDE);


wnd=GetDlgItem(IDC_ZOOMIN);
Visible ? wnd->ShowWindow(SW_SHOW) : wnd->ShowWindow(SW_HIDE);

wnd=GetDlgItem(IDC_ZOOMOUT);
Visible ? wnd->ShowWindow(SW_SHOW) : wnd->ShowWindow(SW_HIDE);

wnd=GetDlgItem(IDC_STATICPANTILT);
Visible ? wnd->ShowWindow(SW_SHOW) : wnd->ShowWindow(SW_HIDE);

wnd=GetDlgItem(IDC_PANLEFT);
Visible ? wnd->ShowWindow(SW_SHOW) : wnd->ShowWindow(SW_HIDE);

wnd=GetDlgItem(IDC_PANRIGHT);
Visible ? wnd->ShowWindow(SW_SHOW) : wnd->ShowWindow(SW_HIDE);

wnd=GetDlgItem(IDC_TILTUP);
Visible ? wnd->ShowWindow(SW_SHOW) : wnd->ShowWindow(SW_HIDE);

wnd=GetDlgItem(IDC_TILTDOWN);
Visible ? wnd->ShowWindow(SW_SHOW) : wnd->ShowWindow(SW_HIDE);

wnd=GetDlgItem(IDC_STATICBRIGHTNESS);
Visible ? wnd->ShowWindow(SW_SHOW) : wnd->ShowWindow(SW_HIDE);

wnd=GetDlgItem(IDC_IRISUP);
Visible ? wnd->ShowWindow(SW_SHOW) : wnd->ShowWindow(SW_HIDE);

wnd=GetDlgItem(IDC_IRISDOWN);
Visible ? wnd->ShowWindow(SW_SHOW) : wnd->ShowWindow(SW_HIDE);

wnd=GetDlgItem(IDC_STATICFLASHIRIS);
Visible ? wnd->ShowWindow(SW_SHOW) : wnd->ShowWindow(SW_HIDE);

wnd=GetDlgItem(IDC_EDITFLASHIRIS);
Visible ? wnd->ShowWindow(SW_SHOW) : wnd->ShowWindow(SW_HIDE);

wnd=GetDlgItem(IDC_CAPTURE);
Visible ? wnd->ShowWindow(SW_SHOW) : wnd->ShowWindow(SW_HIDE);

wnd=GetDlgItem(IDC_STATICUSEFLASH);
Visible ? wnd->ShowWindow(SW_SHOW) : wnd->ShowWindow(SW_HIDE);

wnd=GetDlgItem(IDC_USEFLASHNO);
Visible ? wnd->ShowWindow(SW_SHOW) : wnd->ShowWindow(SW_HIDE);

wnd=GetDlgItem(IDC_USEFLASHYES);
Visible ? wnd->ShowWindow(SW_SHOW) : wnd->ShowWindow(SW_HIDE);

wnd=GetDlgItem(IDC_ADJUST);
Visible ? wnd->ShowWindow(SW_SHOW) : wnd->ShowWindow(SW_HIDE);

wnd=GetDlgItem(IDC_STATICPREVIEWCAPTURE);
Visible ? wnd->ShowWindow(SW_SHOW) : wnd->ShowWindow(SW_HIDE);

wnd=GetDlgItem(IDC_PREVIEWNO);
Visible ? wnd->ShowWindow(SW_SHOW) : wnd->ShowWindow(SW_HIDE);

wnd=GetDlgItem(IDC_PREVIEWYES);
Visible ? wnd->ShowWindow(SW_SHOW) : wnd->ShowWindow(SW_HIDE);

//m_SliderRed.MoveWindow(m_CropWidth + 16,148 + 3,80,54,TRUE);
if (Visible==FALSE){
	if (m_ColorCorrectionLock>=1){
		m_SliderRed.EnableWindow(FALSE);
		m_SliderBlue.EnableWindow (FALSE);
		GetDlgItem(IDC_BUTTONDEFAULT)->EnableWindow(FALSE);
	
	}
	
	else{
		m_SliderRed.EnableWindow(TRUE);
		m_SliderBlue.EnableWindow (TRUE);
		m_SliderRed.SetPos(-m_RedColorCorrection);
        m_SliderBlue.SetPos(-m_BlueColorCorrection);
		CString str;
		str.Format("%d",m_RedColorCorrection);
		m_EditColorRed.SetWindowText(str);
		str.Format("%d",m_BlueColorCorrection);
		m_EditColorBlue.SetWindowText(str);
		GetDlgItem(IDC_BUTTONDEFAULT)->EnableWindow(TRUE);
		}	
	int VerticalSpacing=10;
	
	
	wnd=GetDlgItem(IDC_STATICCOLORCORRECTION);
    wnd->SetWindowPos(NULL,m_CropWidth + 22 , 0 + VerticalSpacing, 0, 0, SWP_NOSIZE | SWP_SHOWWINDOW);

	wnd=GetDlgItem(IDC_STATICRED);
	wnd->SetWindowPos(NULL,m_CropWidth + 47 , 26 + VerticalSpacing, 0, 0, SWP_NOSIZE | SWP_SHOWWINDOW);

	wnd=GetDlgItem(IDC_SLIDERRED);
    wnd->SetWindowPos(NULL,m_CropWidth + 45 , 40 + VerticalSpacing, 0, 0, SWP_NOSIZE | SWP_SHOWWINDOW);
	
    wnd=GetDlgItem(IDC_EDITREDCOLOR);
    wnd->SetWindowPos(NULL,m_CropWidth + 40 , 170 + VerticalSpacing, 0, 0, SWP_NOSIZE | SWP_SHOWWINDOW);
 
	
	wnd=GetDlgItem(IDC_STATICBLUE);
	wnd->SetWindowPos(NULL,m_CropWidth + 47 , 232 + VerticalSpacing, 0, 0, SWP_NOSIZE | SWP_SHOWWINDOW);

	
	wnd=GetDlgItem(IDC_SLIDERBLUE);
    wnd->SetWindowPos(&wndTop,m_CropWidth+ 45,246 + VerticalSpacing,0,0, SWP_NOSIZE | SWP_SHOWWINDOW);
    
	wnd=GetDlgItem(IDC_EDITBLUECOLOR);
    wnd->SetWindowPos(NULL,m_CropWidth + 40 , 376 + VerticalSpacing, 0, 0, SWP_NOSIZE | SWP_SHOWWINDOW);
	
	wnd=GetDlgItem(IDC_BUTTONDEFAULT);wnd->SetWindowPos(NULL,m_CropWidth + 30, 430 + VerticalSpacing,0,0, SWP_NOSIZE | SWP_SHOWWINDOW);	
	
	m_SliderRed.ShowWindow(SW_SHOW);
	m_SliderBlue.ShowWindow(SW_SHOW);
	wnd=GetDlgItem(IDC_STATICCOLORCORRECTION);
	wnd->ShowWindow(SW_SHOW);	
	wnd=GetDlgItem(IDC_EDITREDCOLOR);
	wnd->ShowWindow(SW_SHOW);
    wnd=GetDlgItem(IDC_EDITBLUECOLOR);
	wnd->ShowWindow(SW_SHOW);
	wnd=GetDlgItem(IDC_STATICRED);
	wnd->ShowWindow(SW_SHOW);
	wnd=GetDlgItem(IDC_STATICBLUE);
	wnd->ShowWindow(SW_SHOW);
    wnd=GetDlgItem(IDC_BUTTONDEFAULT);
	wnd->ShowWindow(SW_SHOW);

    }
else{
	m_SliderRed.ShowWindow(SW_HIDE );
	m_SliderBlue.ShowWindow(SW_HIDE   );
	wnd=GetDlgItem(IDC_STATICCOLORCORRECTION);
	wnd->ShowWindow(SW_HIDE   );	
	wnd=GetDlgItem(IDC_EDITREDCOLOR);
	wnd->ShowWindow(SW_HIDE   );
    wnd=GetDlgItem(IDC_EDITBLUECOLOR);
	wnd->ShowWindow(SW_HIDE   );
	wnd=GetDlgItem(IDC_STATICRED);
	wnd->ShowWindow(SW_HIDE   );
	wnd=GetDlgItem(IDC_STATICBLUE);
	wnd->ShowWindow(SW_HIDE   );
	wnd=GetDlgItem(IDC_BUTTONDEFAULT);
	wnd->ShowWindow(SW_HIDE);
    
}

}


//******** Scroll Controls for Live Color Correction**********************************

void CVIDCAP01Dlg::OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	// TODO: Add your message handler code here and/or call default
	CString str;
	char temp;
	if (*pScrollBar==m_SliderRed){
	    temp=m_SliderRed.GetPos();		 
		 temp=(-temp);
		 str.Format ("%d",temp);
		 m_EditColorRed.SetWindowText(str);
		 //m_FlashCapture ? m_RedFlashCorrection=temp : m_RedLiveCorrection=temp;
		 m_RedColorCorrection=temp;
		 VALCam_Control(VC_ColorCorrectImage,m_RedColorCorrection,m_BlueColorCorrection,0,0);
		 VALCam_Control(VC_DisplayCapture,(int)m_hWnd,0,0,0);
		 UpdateData(FALSE);
	}
		else{
		 if (*pScrollBar==m_SliderBlue){
	       temp=m_SliderBlue.GetPos();		 
		   temp=-(temp);
		   str.Format ("%d",temp);
		   m_EditColorBlue.SetWindowText(str);
		  // m_FlashCapture ? m_BlueFlashCorrection=temp : m_BlueLiveCorrection=temp;
		   m_BlueColorCorrection=temp;
		   VALCam_Control(VC_ColorCorrectImage,m_RedColorCorrection,m_BlueColorCorrection,0,0);
		   VALCam_Control(VC_DisplayCapture,(int)m_hWnd,0,0,0);
		   UpdateData(FALSE);
		 }	 
		}
	
	CDialog::OnVScroll(nSBCode, nPos, pScrollBar);
}


//*************************** Sets Color Correction Controls to Zero Offset *****************************
void CVIDCAP01Dlg::OnButtondefault() 
{
   CString strBlue, strRed;
m_RedColorCorrection=0;m_BlueColorCorrection=0;
strRed.Format ("%d",m_RedColorCorrection); strBlue.Format("%d",m_BlueColorCorrection);
m_SliderRed.SetPos (-m_RedColorCorrection);
m_SliderBlue.SetPos(-m_BlueColorCorrection);
m_EditColorRed.SetWindowText (strRed);
m_EditColorBlue.SetWindowText(strBlue); 

VALCam_Control(VC_ColorCorrectImage,0,0,0,0);
VALCam_Control(VC_DisplayCapture,(int)m_hWnd,0,0,0); 

}


//****** Reads Parameters from SDK DLL (usb_sdk.dll)****************************************************
//****** These Parameters are automatically saved and restored in by Usb_SDK.dll.***********************
void CVIDCAP01Dlg::Read_Ini_Values()
{

 m_FlashIrisLevel=VALCam_Control(VC_ReturnFlashIris,0,0,0,0);
 
 m_RedPreviewOffset=VALCam_Control(VC_ReturnLiveRed,0,0,0,0);
 m_BluePreviewOffset=VALCam_Control(VC_ReturnLiveBlue,0,0,0,0);
 m_ChromaLevel=VALCam_Control(VC_ReturnLiveColor,0,0,0,0);

 m_RedFlashOffset=VALCam_Control(VC_ReturnFlashRed,0,0,0,0);
 m_BlueFlashOffset=VALCam_Control(VC_ReturnFlashBlue,0,0,0,0);
 m_FlashChromaLevel=VALCam_Control(VC_ReturnFlashColor,0,0,0,0);

 m_RedColorCorrection=VALCam_Control(VC_ReturnRedPaint,0,0,0,0);
 m_BlueColorCorrection=VALCam_Control(VC_ReturnBluePaint,0,0,0,0);

 m_Sharpness=VALCam_Control(VC_ReturnSharpness,0,0,0,0);
 m_Aperature=VALCam_Control(VC_ReturnFGSharpness,0,0,0,0);

 m_CropWidth=VALCam_Control(VC_ReturnCropWidth,0,0,0,0);
 m_CropHeight=VALCam_Control(VC_ReturnCropHeight,0,0,0,0);
 m_CropStartX=VALCam_Control(VC_ReturnCropStartX,0,0,0,0);
 m_CropStartY=VALCam_Control(VC_ReturnCropStartY,0,0,0,0);

 m_ScaleX=m_CropWidth;
 m_ScaleY=m_CropHeight;

m_FlashColorCorrectionType=VALCam_Control(VC_ReturnFlashColorCorrectionType,0,0,0,0);

m_AutoWhite=VALCam_Control(VC_ReturnAutoWhite,0,0,0,0);
}


//*************** Centers PTZ postion of Camera********************************************************
void CVIDCAP01Dlg::OnButtonhome() 
{
VALCam_Control(VC_SetPanTiltCenter,0,0,0,0);	
}


void CVIDCAP01Dlg::OnLButtonDblClk(UINT nFlags, CPoint point)
{
	CString strX,strY;
	//if (point.x <= m_CropWidth || point.y <=m_CropHeight){
	
		if (m_CameraType>=4) 
	   {		 
		//Beep(1000,1000);
		int Width, Height;
	    Width=m_CropWidth/2;
		Height=m_CropHeight/2;
		CPoint StartingPoint;
		StartingPoint=point;
		//VALCam_Control(VC_SetPanTiltPosition, (Width + m_XCenterOffset)- point.x ,  point.y - (Height -m_YCenterOffset),0,0);
		//VALCam_Control(VC_SetPanTiltPosition, (Width) - point.x ,  point.y - (Height),0,0);
		//VALCam_Control(VC_SetPanTiltPosition, (point.x - m_XCenterOffset+Width)  , (Height- m_YCenterOffset) - point.y  ,0,0);	
		//VALCam_Control(VC_SetPanTiltPosition, (m_XCenterOffset+Width)- point.x ,  point.y - (Height- m_YCenterOffset),0,0);	
		VALCam_Control(VC_SetPanTiltPosition, (Width)- StartingPoint.x ,  StartingPoint.y - (Height),0,0);
		}
	//}
     
	CDialog::OnLButtonDblClk(nFlags, point);
}


void CVIDCAP01Dlg::OnLButtonDown(UINT nFlags, CPoint point)
{
	
	if (point.x <= m_CropWidth && point.y<=m_CropHeight){
      m_SetAutoPositionOffset=TRUE;
	  m_CMouseOrigin=point;
	}
	else{
		m_SetAutoPositionOffset=FALSE;
	}

	CDialog::OnLButtonDown(nFlags, point);
}

void CVIDCAP01Dlg::OnLButtonUp(UINT nFlags, CPoint point)
{
	CString strX,strY;
	if ((abs(point.x - m_CMouseOrigin.x)<=3) && (abs(point.y - m_CMouseOrigin.y)<=3)) m_SetAutoPositionOffset=FALSE;
	if (m_SetAutoPositionOffset==FALSE)
	{
		//Beep(1000,1000);
		//m_SetAutoPositionOffset=FALSE;
		CWnd::OnLButtonUp(nFlags, point);
		return;
	}
	//***************Move camera pixel distance from left mouse down to new postion of left mouse up.	
	if (point.x <= m_CropWidth && point.y<=m_CropHeight){
		VALCam_Control(VC_SetPanTiltPosition, point.x - m_CMouseOrigin.x ,m_CMouseOrigin.y - point.y ,0,0);
	}
	//strX.Format("%d",point.x);
    //strY.Format("%d",point.y);
	//MessageBox("x=" + strX + "y=" + strY,"TEST",0);
	CDialog::OnLButtonUp(nFlags, point);
}
