// VIDCAP01Dlg.h : header file
//

//****************************  Revisions ********************************************************

// 12-27-04 Added Support for Compressed/Non-Compressed Non Flash Captures 

//****************************  Revisions ********************************************************



//*************************** Lead Tools ***************************************************************

//****************************************************************************************************
#include "MyPropSheet.h"
#include "AutoPosition.h"

#if !defined(AFX_VIDCAP01DLG_H__56B729EF_D985_4D3C_87BB_5EC4B925884E__INCLUDED_)
#define AFX_VIDCAP01DLG_H__56B729EF_D985_4D3C_87BB_5EC4B925884E__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

/////////////////////////////////////////////////////////////////////////////
// CVIDCAP01Dlg dialog




class  CVIDCAP01Dlg : public CDialog
{
// Construction
public:
	POINT m_CMouseOrigin;
	char m_BlueColorCorrection;
	char m_RedColorCorrection;
	UINT m_ScaleY;
	UINT m_ScaleX;
	BOOL m_SetAutoPositionOffset;
	BOOL m_AutoPositionOffset;
	int m_FlashColorCorrectionType;
	int m_CropStartY;
	int m_CropStartX;
	void Read_Ini_Values();
	int m_CompressionFactor;
	CString m_FileName;
	CString m_Path;
	BOOL m_ColorAdjustVisible ;
	char m_BlueFlashCorrection;
	char m_RedFlashCorrection;
    char m_BlueLiveCorrection;
	char m_RedLiveCorrection;
	int  m_ColorCorrectionLock;
 	void DisplayPreviewCapture();
	void Make_Interface_Visible(BOOL Visible);
	COLORREF * m_pPixelBuffer;
	int m_FlashColorCorrection;
	BOOL m_FirstTime;
	BYTE m_SetReferenceBlue;
	BYTE m_SetReferenceRed;
	BYTE m_LockIris;
	BYTE m_BlueLockGain;
	BYTE m_RedLockGain;
	int m_AutoWhite;
	int m_FlashDistanceCompensation;
	BOOL m_LockZoom;
	CPropertyPage * m_page5;
	
//	BOOL m_SetAutoPositionOffset;
	int m_YCenterOffset;
	int m_XCenterOffset;
	BOOL m_ZoomLocked;
	BOOL m_TiltReverse;
	BOOL m_PanReverse;
	BOOL m_ManualCorrectionFactor;
	int m_CalibrationError;
	BOOL m_AutoZoomGood;
 	int m_AutoPositionEnabled;
	UINT m_ZoomAutoPosition;
//	CString m_AutoCorrectionFactorStr;
	UINT m_KeyCount;
//	float m_AutoCorrectionFactor;
	int m_CalibrationPosition;
	BOOL m_SecondCalibrationPoint;
	BOOL m_FirstCalibrationPoint;
	BOOL m_InAutoPositionCalibration;
	void UpdateDialog();
	
	//CCMouseCapture CMouseCapture;
	CPoint m_MouseOrigin;
	BOOL m_RightMouseDown;
	BOOL RightMouseDown;
	int m_DefaultSharpness;
	int m_DigitalSmoothing;
	void BogusCapture();
	
	BOOL Control;
	BOOL Shift;
//	void DetermineCameraType();
	//void NoCompression();
//	void SetEVIMode();
	BOOL m_EVIMode;
	int m_CameraType;
	void FlashIrisLevelDistance();
	BOOL Up;
	BOOL Down;
	BOOL Right;
	BOOL Left;
	BOOL Add;
	BOOL Subtract;
	
	
	BOOL m_EnablePassWord;
	BOOL m_Passed;
	CString m_PassWord;
	int m_UsePassword;
	int m_LiveCapture;
	//void MinimalCompression();
	int m_CropSelect;
	//void RestoreLivePreview();
	int m_CropHeight;
	int m_CropWidth;
	int CropWidth;
	int CropHeight;
	void ResizeMainWindow();
//	void GetPositions();
//	void CroppingControl();
	int m_AutoFocus;
	int m_CompressionLevel;
	int m_PTZSpeed;
	int m_DefaultFlashDelay;
	int m_DefaultAperature;
	int m_Aperature;
	int m_DefaultRedPreviewOffset;
	int m_DefaultBluePreviewOffset;
	int m_DefaultRedFlashOffset;
	int m_DefaultBlueFlashOffset;
	int m_DefaultChromaPreviewLevel;
	int m_DefaultChromaFlashLevel;
	RECT m_MainRect;
	void PositionDialog();
	CMyPropSheet* PropSheet;
	//void InspectBitmap();
	//void SetFrameGrabber();
	int m_Contrast;
	int m_Brightness;
	int m_FlashChromaLevel;
	int m_ChromaLevel;
	BOOL m_ExtStopCmd;
	HWND m_hTwain;
	int m_WindowWidth;
	//void SetPreviewChromaLevel();
//	void m_SharpenBitmap();
	//void SetFlashChromaLevel();
	int m_BlueFlashOffset;
	int m_RedFlashOffset;
	int m_BluePreviewOffset;
	int m_RedPreviewOffset;
	int m_BlueSunlight;
	int m_RedSunlight;
	BYTE m_BlueAutoWhite;
	BYTE m_RedAutoWhite;
	//void ReadRedAndBlueGain();
	int m_AutoWhiteBlue;
	int m_AutoWhiteRed;
	
	int m_FlashIrisLevel;
	int m_DisplayVertSize;
	int m_DisplayHorzSize;
	int m_Sharpness;
	
	int m_FlashDelay;
	int m_LeftPos;
	int m_TopPos;
//	CComPtr <IVc3Ctrl> m_pVc3Ctrl; 
	//void init_Camera();
	CBitmap m_bmpZoomOut;
	CBitmap m_bmpZoomIn;
	CBitmap m_bmpTiltUp;
	CBitmap m_bmpTiltDown;
	CBitmap m_bmpPanLeft;
	CBitmap m_bmpPanRight;
	CBitmap m_bmpIrisUp;
	CBitmap m_bmpIrisDown;
	void PrepareBitmaps();
	CBitmapButton m_bbIrisup;
	int m_FlashIrisLevelint;
    //HRESULT GrabBitmapFromStream();
	void SetPreviewInterface();
	
	void SetControlParameters();
	int m_ZoomActive;
	unsigned char * m_pImageBuffer;
//	BITMAPHANDLE m_LeadBitMap;
	//HRESULT GetUnconnectedPin(IBaseFilter *pFilter,PIN_DIRECTION PinDir,IPin **ppPin);
//	BOOL ClearGraph();
//	HRESULT SetupVideoWindow();
	//HRESULT GetInterfaces(void);
	//HRESULT FindVidCapDevice(IBaseFilter **);
	CVIDCAP01Dlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	//{{AFX_DATA(CVIDCAP01Dlg)
	enum { IDD = IDD_VIDCAP01_DIALOG };
	CEdit	m_EditColorRed;
	CEdit	m_EditColorBlue;
	CSliderCtrl	m_SliderBlue;
	int		m_PreviewCapture;
	int		m_FlashCapture;
	int		m_MouseX;
	int		m_MouseY;
	
	CSliderCtrl m_SliderRed;
	CString	m_FlashIrisLevelstr;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CVIDCAP01Dlg)
	public:
	virtual BOOL PreTranslateMessage(MSG* pMsg);
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
//	virtual LRESULT WindowProc(UINT message, WPARAM wParam, LPARAM lParam);
	//}}AFX_VIRTUAL

// Implementation
protected:

	HICON m_hIcon;
    
	// Generated message map functions
	//{{AFX_MSG(CVIDCAP01Dlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg void OnCapture();
	afx_msg void OnClose();
	afx_msg void OnIrisdown();
	afx_msg void OnIrisup();
	afx_msg BOOL OnSetCursor(CWnd* pWnd, UINT nHitTest, UINT message);
	afx_msg void OnDontsave();
	afx_msg void OnSave();
	afx_msg void OnUseflashno();
	afx_msg void OnUseflashyes();
	afx_msg void OnAdjust();
	afx_msg void OnPreviewno();
	afx_msg void OnPreviewyes();
	afx_msg void OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	afx_msg void OnButtondefault();
	afx_msg void OnButtonhome();
	afx_msg void OnLButtonDblClk(UINT nFlags, CPoint point);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
public:
	
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_VIDCAP01DLG_H__56B729EF_D985_4D3C_87BB_5EC4B925884E__INCLUDED_)


